-
- declare -x ABI="arm64"
- declare -x ABI_MIPS=""
- declare -x ABI_PPC=""
- declare -x ABI_S390=""
- declare -x ABI_X86=""
- declare -a ALL_AUTOTOOLS_MACROS=([0]="AC_PROG_LIBTOOL" [1]="AM_PROG_LIBTOOL" [2]="LT_INIT" [3]="LT_CONFIG_LTDL_DIR" [4]="AC_CONFIG_HEADERS" [5]="AC_CONFIG_HEADER" [6]="AM_CONFIG_HEADERS" [7]="AM_CONFIG_HEADER" [8]="AC_CONFIG_SUBDIRS" [9]="AC_CONFIG_AUX_DIR" [10]="AC_CONFIG_MACRO_DIR" [11]="AM_INIT_AUTOMAKE" [12]="AM_GLIB_GNU_GETTEXT" [13]="AM_GNU_GETTEXT_VERSION" [14]="AM_GNU_GETTEXT_REQUIRE_VERSION" [15]="AC_PROG_INTLTOOL" [16]="IT_PROG_INTLTOOL" [17]="GTK_DOC_CHECK" [18]="GNOME_DOC_INIT")
- declare -x ALSA_CARDS=""
- declare -x APACHE2_MODULES=""
- declare -x APACHE2_MPMS=""
- declare -x ARCH="arm64"
- declare -- AT_M4DIR=""
- declare -- AT_SYS_M4DIR=""
- declare -- AUTOTOOLS_AUTO_DEPEND="yes"
- declare -- AUTOTOOLS_DEPEND="!<sys-devel/gettext-0.18.1.1-r3
- || ( >=sys-devel/automake-1.16.1:1.16 >=sys-devel/automake-1.15.1:1.15 )
- >=sys-devel/autoconf-2.69
- >=sys-devel/libtool-2.4"
- declare BDEPEND="virtual/pkgconfig "
- declare -x BOOTSTRAP_USE="cxx unicode internal-glib split-usr python_targets_python3_6 python_targets_python2_7 multilib"
- declare -x BUILD_CFLAGS="-march=native -O2 -pipe -fomit-frame-pointer"
- declare -x BUILD_CPPFLAGS=""
- declare -x BUILD_CXXFLAGS="-march=native -O2 -pipe -fomit-frame-pointer"
- declare -x BUILD_LDFLAGS="-Wl,-O1 -Wl,--as-needed"
- declare -x CALLIGRA_EXPERIMENTAL_FEATURES=""
- declare -x CALLIGRA_FEATURES=""
- declare -x CAMERAS=""
- declare -x CBUILD="x86_64-pc-linux-gnu"
- declare -x CFLAGS="-march=armv8-a+crc -mtune=cortex-a53 -ftree-vectorize -O2 -pipe -fomit-frame-pointer -Wno-error -ggdb "
- declare -x CFLAGS_default
- declare -x CHOST="aarch64-unknown-linux-gnu"
- declare -x CHOST_arm64="aarch64-unknown-linux-gnu"
- declare -x CHOST_default="aarch64-unknown-linux-gnu"
- declare -x COLLECTD_PLUGINS=""
- declare -x CPU_FLAGS_ARM=""
- declare -x CPU_FLAGS_X86=""
- declare -x CTARGET_default="aarch64-unknown-linux-gnu"
- declare -x CURL_SSL=""
- declare -x CXXFLAGS="-march=armv8-a+crc -mtune=cortex-a53 -ftree-vectorize -O2 -pipe -fomit-frame-pointer -Wno-error -ggdb "
- declare -x DCC_EMAILLOG_WHOM_TO_BLAME=""
- declare -x DEFAULT_ABI="arm64"
- declare -x DEFINED_PHASES=" compile configure install postinst prepare test"
- declare DEPEND="app-text/docbook-xml-dtd:4.3
- app-text/docbook-xml-dtd:4.4
- app-text/docbook-xml-dtd:4.5
- nls? ( sys-devel/gettext ) >=app-portage/elt-patches-20170815 !<sys-devel/gettext-0.18.1.1-r3
- || ( >=sys-devel/automake-1.16.1:1.16 >=sys-devel/automake-1.15.1:1.15 )
- >=sys-devel/autoconf-2.69
- >=sys-devel/libtool-2.4 filecaps? ( sys-libs/libcap )"
- declare DESCRIPTION="Linux-PAM (Pluggable Authentication Modules)"
- declare -x DESTTREE="/usr"
- declare -x DIROPTIONS="-m0755"
- declare -x EAPI="6"
- declare -x ELIBC="glibc"
- declare -x ENLIGHTENMENT_MODULES=""
- declare -x ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
- declare -x EVCS_OFFLINE="1"
- declare -x EXEOPTIONS="-m0755"
- declare -x FCFLAGS="-O2"
- declare -x FETCHCOMMAND_SSH="bash -c \"x=\\\${2#ssh://} ; host=\\\${x%%/*} ; port=\\\${host##*:} ; host=\\\${host%:*} ; [[ \\\${host} = \\\${port} ]] && port= ; exec rsync --rsh=\\\"ssh \\\${port:+-p\\\${port}} \\\${3}\\\" -avP \\\"\\\${host}:/\\\${x#*/}\\\" \\\"\\\$1\\\"\" rsync \"\${DISTDIR}/\${FILE}\" \"\${URI}\" \"\${PORTAGE_SSH_OPTS}\""
- declare -x FFLAGS="-O2"
- declare -x FFTOOLS=""
- declare -x GCC_SPECS=""
- declare -x GENTOO_WS="/home/necktwi/Workspace/Gentoo/"
- declare -x GPSD_PROTOCOLS=""
- declare -x GRUB_PLATFORMS=""
- declare HDEPEND=""
- declare HOMEPAGE="https://github.com/linux-pam/linux-pam"
- declare -x HOSTCC="x86_64-pc-linux-gnu-gcc"
- declare -x INHERITED=" toolchain-funcs multilib libtool autotools eapi7-ver db-use fcaps multibuild multilib-build multilib-minimal"
- declare -x INPUT_DEVICES=""
- declare -x INSDESTTREE=""
- declare -x INSOPTIONS="-m0644"
- declare IUSE="audit berkdb +cracklib debug nis nls +pie selinux static-libs +filecaps abi_x86_32 abi_x86_64 abi_x86_x32 abi_mips_n32 abi_mips_n64 abi_mips_o32 abi_ppc_32 abi_ppc_64 abi_s390_32 abi_s390_64"
- declare -x IUSE_EFFECTIVE="abi_mips_n32 abi_mips_n64 abi_mips_o32 abi_ppc_32 abi_ppc_64 abi_s390_32 abi_s390_64 abi_x86_32 abi_x86_64 abi_x86_x32 alpha amd64 amd64-fbsd amd64-linux arm arm64 audit berkdb cracklib debug elibc_AIX elibc_Cygwin elibc_Darwin elibc_DragonFly elibc_FreeBSD elibc_HPUX elibc_Interix elibc_NetBSD elibc_OpenBSD elibc_SunOS elibc_Winnt elibc_bionic elibc_glibc elibc_mingw elibc_mintlib elibc_musl elibc_uclibc filecaps hppa ia64 kernel_AIX kernel_Darwin kernel_FreeBSD kernel_HPUX kernel_NetBSD kernel_OpenBSD kernel_SunOS kernel_Winnt kernel_freemint kernel_linux m68k m68k-mint mips nis nls pie ppc ppc-aix ppc-macos ppc64 ppc64-linux prefix prefix-chain prefix-guest s390 selinux sh sparc sparc-solaris sparc64-solaris static-libs userland_BSD userland_GNU x64-cygwin x64-macos x64-solaris x86 x86-cygwin x86-fbsd x86-linux x86-macos x86-solaris x86-winnt"
- declare -x IUSE_IMPLICIT="prefix prefix-chain prefix-guest"
- declare -x KERNEL="linux"
- declare -x KERNEL_ABI="arm64"
- declare -x KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~amd64-linux ~x86-linux"
- declare -x L10N=""
- declare -x LANG="en_US.utf8"
- declare -x LCD_DEVICES=""
- declare -x LC_COLLATE="C"
- declare -x LC_CTYPE="en_US.utf8"
- declare -x LC_MESSAGES="C"
- declare -x LDFLAGS="-Wl,-O1 -Wl,--as-needed"
- declare -x LDFLAGS_default
- declare -x LIBDIR_arm64="lib64"
- declare -x LIBDIR_default="lib"
- declare -x LIBOPTIONS="-m0644"
- declare -x LIBREOFFICE_EXTENSIONS=""
- declare -x LICENSE="|| ( BSD GPL-2 )"
- declare -x LIRC_DEVICES=""
- declare -x LLVM_TARGETS=""
- declare -x MAIL="/var/mail/necktwi"
- declare -x MAKEOPTS="-j5"
- declare -x MANPAGER="manpager"
- declare -x MONKEYD_PLUGINS=""
- declare -x MULTILIB_ABIS="arm64"
- declare -x MULTILIB_STRICT_DENY="64-bit.*shared object"
- declare -x MULTILIB_STRICT_DIRS="/lib32 /lib /usr/lib32 /usr/lib /usr/kde/*/lib32 /usr/kde/*/lib /usr/qt/*/lib32 /usr/qt/*/lib /usr/X11R6/lib32 /usr/X11R6/lib"
- declare -x MULTILIB_STRICT_EXEMPT="(perl5|gcc|gcc-lib|binutils|eclipse-3|debug|portage|udev|systemd|clang|python-exec|llvm)"
- declare -- MULTILIB_USEDEP="abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_ppc_32(-)?,abi_ppc_64(-)?,abi_s390_32(-)?,abi_s390_64(-)?"
- declare -x NETBEANS="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml"
- declare -x NETBEANS_MODULES=""
- declare -x NGINX_MODULES_HTTP=""
- declare -x NGINX_MODULES_MAIL=""
- declare -x NGINX_MODULES_STREAM=""
- declare -x OFED_DRIVERS=""
- declare -x OFFICE_IMPLEMENTATION=""
- declare -x OPENGL_PROFILE="xorg-x11"
- declare -x OPENMPI_FABRICS=""
- declare -x OPENMPI_OFED_FEATURES=""
- declare -x OPENMPI_RM=""
- declare -x PATH="/usr/lib64/ccache/bin:/usr/lib/portage/python3.6/ebuild-helpers/xattr:/usr/lib/portage/python3.6/ebuild-helpers:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt/bin"
- declare PDEPEND="sys-auth/pambase "
- declare -x PHP_TARGETS=""
- declare -x PKG_CONFIG_PATH="/usr/aarch64-unknown-linux-gnu/usr/lib/pkgconfig/"
- declare -x PORTAGE_COMPRESSION_COMMAND="bzip2"
- declare -a PORTAGE_DOCOMPRESS=([0]="/usr/share/doc" [1]="/usr/share/info" [2]="/usr/share/man")
- declare -x PORTAGE_DOCOMPRESS_SIZE_LIMIT="128"
- declare -a PORTAGE_DOCOMPRESS_SKIP=([0]="/usr/share/doc/pam-1.3.1/html")
- declare -a PORTAGE_DOSTRIP=([0]="/")
- declare -a PORTAGE_DOSTRIP_SKIP=()
- declare -x POSTGRES_TARGETS=""
- declare -x PROFILE_ONLY_VARIABLES="ARCH ELIBC IUSE_IMPLICIT KERNEL USERLAND USE_EXPAND_IMPLICIT USE_EXPAND_UNPREFIXED USE_EXPAND_VALUES_ARCH USE_EXPAND_VALUES_ELIBC USE_EXPAND_VALUES_KERNEL USE_EXPAND_VALUES_USERLAND"
- declare -x PROPERTIES=""
- declare -x PYTHONDONTWRITEBYTECODE="1"
- declare -x PYTHON_SINGLE_TARGET=""
- declare -x PYTHON_TARGETS=""
- declare -x QEMU_SOFTMMU_TARGETS=""
- declare -x QEMU_USER_TARGETS=""
- declare RDEPEND="app-text/docbook-xml-dtd:4.3
- app-text/docbook-xml-dtd:4.4
- app-text/docbook-xml-dtd:4.5
- nls? ( sys-devel/gettext )
- audit? ( >=sys-process/audit-2.2.2[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_ppc_32(-)?,abi_ppc_64(-)?,abi_s390_32(-)?,abi_s390_64(-)?] )
- berkdb? ( >=sys-libs/db-4.8.30-r1:=[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_ppc_32(-)?,abi_ppc_64(-)?,abi_s390_32(-)?,abi_s390_64(-)?] )
- cracklib? ( >=sys-libs/cracklib-2.9.1-r1[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_ppc_32(-)?,abi_ppc_64(-)?,abi_s390_32(-)?,abi_s390_64(-)?] )
- selinux? ( >=sys-libs/libselinux-2.2.2-r4[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_ppc_32(-)?,abi_ppc_64(-)?,abi_s390_32(-)?,abi_s390_64(-)?] )
- nis? ( >=net-libs/libtirpc-0.2.4-r2[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_ppc_32(-)?,abi_ppc_64(-)?,abi_s390_32(-)?,abi_s390_64(-)?] )
- nls? ( >=virtual/libintl-0-r1[abi_x86_32(-)?,abi_x86_64(-)?,abi_x86_x32(-)?,abi_mips_n32(-)?,abi_mips_n64(-)?,abi_mips_o32(-)?,abi_ppc_32(-)?,abi_ppc_64(-)?,abi_s390_32(-)?,abi_s390_64(-)?] )
- !<sys-apps/openrc-0.11.8
- !sys-auth/openpam
- !sys-auth/pam_userdb "
- declare REPOSITORY
- declare REQUIRED_USE=""
- declare -x RESTRICT=""
- declare -x RESUMECOMMAND_SSH="bash -c \"x=\\\${2#ssh://} ; host=\\\${x%%/*} ; port=\\\${host##*:} ; host=\\\${host%:*} ; [[ \\\${host} = \\\${port} ]] && port= ; exec rsync --rsh=\\\"ssh \\\${port:+-p\\\${port}} \\\${3}\\\" -avP \\\"\\\${host}:/\\\${x#*/}\\\" \\\"\\\$1\\\"\" rsync \"\${DISTDIR}/\${FILE}\" \"\${URI}\" \"\${PORTAGE_SSH_OPTS}\""
- declare -x ROS_MESSAGES=""
- declare -x RUBY_TARGETS=""
- declare -x S="/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-libs/pam-1.3.1/work/linux-pam-1.3.1"
- declare -x SANDBOX_DEBUG="0"
- declare -x SANDBOX_DENY=""
- declare -x SANDBOX_PREDICT="/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-libs/pam-1.3.1/homedir"
- declare -x SANDBOX_READ="/:/usr/aarch64-unknown-linux-gnu/tmp:/var/CCache"
- declare -x SANDBOX_VERBOSE="1"
- declare -x SANDBOX_WRITE=":/dev/console:/dev/fd:/dev/full:/dev/null:/dev/ptmx:/dev/pts/:/dev/pty:/dev/shm:/dev/tts:/dev/tty:/dev/vc/:/dev/zero:/proc/self/fd:/tmp/:/usr/aarch64-unknown-linux-gnu/tmp:/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-libs/pam-1.3.1/homedir/.bash_history:/usr/lib/cf:/usr/lib/conftest:/usr/lib32/cf:/usr/lib32/conftest:/usr/lib64/cf:/usr/lib64/conftest:/usr/tmp/cf:/usr/tmp/conftest:/var/CCache:/var/tmp/"
- declare -x SANE_BACKENDS=""
- declare -x SHELL="/bin/bash"
- declare -x SLOT="0"
- declare SRC_URI="https://github.com/linux-pam/linux-pam/archive/v1.3.1.tar.gz -> pam-1.3.1.tar.gz"
- declare -x SSH_CLIENT="192.168.2.21 61325 22"
- declare -x SSH_CONNECTION="192.168.2.21 61325 192.168.2.28 22"
- declare -x SSH_TTY="/dev/pts/0"
- declare -x TWISTED_DISABLE_WRITING_OF_PLUGIN_CACHE="1"
- declare -x UNCACHED_ERR_FD=""
- declare -x USE="arm64 berkdb cracklib elibc_glibc filecaps kernel_linux nls pie userland_GNU"
- declare -x USERLAND="GNU"
- declare -x USE_EXPAND_IMPLICIT="ARCH ELIBC KERNEL USERLAND"
- declare -x USE_EXPAND_UNPREFIXED="ARCH"
- declare -x USE_EXPAND_VALUES_ARCH="alpha amd64 amd64-fbsd amd64-linux arm arm64 hppa ia64 m68k m68k-mint mips ppc ppc64 ppc64-linux ppc-aix ppc-macos s390 sh sparc sparc64-solaris sparc-solaris x64-cygwin x64-macos x64-solaris x86 x86-cygwin x86-fbsd x86-linux x86-macos x86-solaris x86-winnt"
- declare -x USE_EXPAND_VALUES_ELIBC="AIX bionic Cygwin Darwin DragonFly FreeBSD glibc HPUX Interix mingw mintlib musl NetBSD OpenBSD SunOS uclibc Winnt"
- declare -x USE_EXPAND_VALUES_KERNEL="AIX Darwin FreeBSD freemint HPUX linux NetBSD OpenBSD SunOS Winnt"
- declare -x USE_EXPAND_VALUES_USERLAND="BSD GNU"
- declare -x UWSGI_PLUGINS=""
- declare -x VIDEO_CARDS=""
- declare -x VISUAL="emacs"
- declare -x VOICEMAIL_STORAGE=""
- declare -x WANT_AUTOCONF="2.5"
- declare -x WANT_AUTOMAKE="1.16"
- declare -x WANT_LIBTOOL="latest"
- declare -x XFCE_PLUGINS=""
- declare -x XTABLES_ADDONS=""
- declare -- _AUTOTOOLS_ECLASS="1"
- declare -x _E_DOCDESTTREE_=""
- declare -x _E_EXEDESTTREE_=""
- declare -- _FCAPS_ECLASS="1"
- declare -a _LATEST_AUTOMAKE=([0]="1.16.1:1.16" [1]="1.15.1:1.15")
- declare -- _LIBTOOL_ECLASS="1"
- declare -- _MULTIBUILD="1"
- declare -- _MULTILIB_BUILD="1"
- declare -- _MULTILIB_ECLASS="1"
- declare -a _MULTILIB_FLAGS=([0]="abi_x86_32:x86,x86_fbsd,x86_freebsd,x86_linux,x86_macos,x86_solaris" [1]="abi_x86_64:amd64,amd64_fbsd,x64_freebsd,amd64_linux,x64_macos,x64_solaris" [2]="abi_x86_x32:x32" [3]="abi_mips_n32:n32" [4]="abi_mips_n64:n64" [5]="abi_mips_o32:o32" [6]="abi_ppc_32:ppc,ppc_aix,ppc_macos" [7]="abi_ppc_64:ppc64" [8]="abi_s390_32:s390" [9]="abi_s390_64:s390x")
- declare -- _TOOLCHAIN_FUNCS_ECLASS="1"
- declare -- __AUTOTOOLS_AUTO_DEPEND="yes"
- declare -- _libtool_atom=">=sys-devel/libtool-2.4"
- declare -x ac_cv_header_xcrypt_h="no"
- declare -- phase_func
- declare -- started_applying="1"
- __eapi6_src_install ()
- {
- if [[ -f Makefile || -f GNUmakefile || -f makefile ]]; then
- emake DESTDIR="${D}" install;
- fi;
- einstalldocs
- }
- __eapi6_src_prepare ()
- {
- if [[ $(declare -p PATCHES 2>/dev/null) == "declare -a"* ]]; then
- [[ ${#PATCHES[@]} -gt 0 ]] && eapply "${PATCHES[@]}";
- else
- if [[ -n ${PATCHES} ]]; then
- eapply ${PATCHES};
- fi;
- fi;
- eapply_user
- }
- _at_uses_autoheader ()
- {
- _at_uses_pkg A{C,M}_CONFIG_HEADER{S,}
- }
- _at_uses_automake ()
- {
- _at_uses_pkg AM_INIT_AUTOMAKE
- }
- _at_uses_gettext ()
- {
- _at_uses_pkg AM_GNU_GETTEXT_{,REQUIRE_}VERSION
- }
- _at_uses_glibgettext ()
- {
- _at_uses_pkg AM_GLIB_GNU_GETTEXT
- }
- _at_uses_gnomedoc ()
- {
- _at_uses_pkg GNOME_DOC_INIT
- }
- _at_uses_gtkdoc ()
- {
- _at_uses_pkg GTK_DOC_CHECK
- }
- _at_uses_intltool ()
- {
- _at_uses_pkg {AC,IT}_PROG_INTLTOOL
- }
- _at_uses_libltdl ()
- {
- _at_uses_pkg LT_CONFIG_LTDL_DIR
- }
- _at_uses_libtool ()
- {
- _at_uses_pkg A{C,M}_PROG_LIBTOOL LT_INIT
- }
- _at_uses_pkg ()
- {
- if [[ -n $(autotools_check_macro "$@") ]]; then
- return 0;
- else
- local macro args=();
- for macro in "$@";
- do
- args+=(-e "^[[:space:]]*${macro}\>");
- done;
- egrep -q "${args[@]}" configure.??;
- fi
- }
- _automake_version ()
- {
- autotools_run_tool --at-output automake --version 2> /dev/null | sed -n -e '1{s:.*(GNU automake) ::p;q}'
- }
- _autotools_m4dir_include ()
- {
- local x include_opts flag;
- [[ ${WANT_AUTOCONF} == "2.1" ]] && flag="l" || flag="I";
- for x in "$@";
- do
- case ${x} in
- -${flag})
-
- ;;
- *)
- [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist";
- include_opts+=" -${flag} ${x}"
- ;;
- esac;
- done;
- echo ${include_opts}
- }
- _clang_fullversion ()
- {
- local ver="$1";
- shift;
- set -- $($(tc-getCPP "$@") -E -P - <<<"__clang_major__ __clang_minor__ __clang_patchlevel__");
- eval echo "$ver"
- }
- _eapply_patch ()
- {
- local f=${1};
- local prefix=${2};
- started_applying=1;
- ebegin "${prefix:-Applying }${f##*/}";
- ${patch_cmd} -p1 -f -s -g0 --no-backup-if-mismatch "${patch_options[@]}" < "${f}";
- failed=${?};
- if ! eend "${failed}"; then
- __helpers_die "patch -p1 ${patch_options[*]} failed with ${f}";
- fi
- }
- _elibtoolize ()
- {
- local LIBTOOLIZE=${LIBTOOLIZE:-$(type -P glibtoolize > /dev/null && echo glibtoolize || echo libtoolize)};
- if [[ $1 == "--auto-ltdl" ]]; then
- shift;
- _at_uses_libltdl && set -- "$@" --ltdl;
- fi;
- [[ -f GNUmakefile.am || -f Makefile.am ]] && set -- "$@" --automake;
- autotools_run_tool ${LIBTOOLIZE} "$@"
- }
- _gcc-install-dir ()
- {
- echo "$(LC_ALL=C $(tc-getCC) -print-search-dirs 2> /dev/null | awk '$1=="install:" {print $2}')"
- }
- _gcc-specs-directive_raw ()
- {
- local cc=$(tc-getCC);
- local specfiles=$(LC_ALL=C ${cc} -v 2>&1 | awk '$1=="Reading" {print $NF}');
- ${cc} -dumpspecs 2> /dev/null | cat - ${specfiles} | awk -v directive=$1 'BEGIN { pspec=""; spec=""; outside=1 }
- $1=="*"directive":" { pspec=spec; spec=""; outside=0; next }
- outside || NF==0 || ( substr($1,1,1)=="*" && substr($1,length($1),1)==":" ) { outside=1; next }
- spec=="" && substr($0,1,1)=="+" { spec=pspec " " substr($0,2); next }
- { spec=spec $0 }
- END { print spec }';
- return 0
- }
- _gcc-specs-exists ()
- {
- [[ -f $(_gcc-install-dir)/$1 ]]
- }
- _gcc_fullversion ()
- {
- local ver="$1";
- shift;
- set -- $($(tc-getCPP "$@") -E -P - <<<"__GNUC__ __GNUC_MINOR__ __GNUC_PATCHLEVEL__");
- eval echo "$ver"
- }
- _multibuild_run ()
- {
- local i=1;
- while [[ ${!i} == _* ]]; do
- (( i += 1 ));
- done;
- [[ ${i} -le ${#} ]] && einfo "${v}: running ${@:${i}}";
- "${@}"
- }
- _multilib_multibuild_wrapper ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local ABI=${MULTIBUILD_VARIANT#*.};
- local -r MULTILIB_ABI_FLAG=${MULTIBUILD_VARIANT%.*};
- multilib_toolchain_setup "${ABI}";
- readonly ABI;
- "${@}"
- }
- _tc-getPROG ()
- {
- local tuple=$1;
- local v var vars=$2;
- local prog=($3);
- var=${vars%% *};
- for v in ${vars};
- do
- if [[ -n ${!v} ]]; then
- export ${var}="${!v}";
- echo "${!v}";
- return 0;
- fi;
- done;
- local search=;
- [[ -n $4 ]] && search=$(type -p $4-${prog[0]});
- [[ -z ${search} && -n ${!tuple} ]] && search=$(type -p ${!tuple}-${prog[0]});
- [[ -n ${search} ]] && prog[0]=${search##*/};
- export ${var}="${prog[*]}";
- echo "${!var}"
- }
- _ver_compare ()
- {
- local va=${1} vb=${2} a an al as ar b bn bl bs br re LC_ALL=C;
- re="^([0-9]+(\.[0-9]+)*)([a-z]?)((_(alpha|beta|pre|rc|p)[0-9]*)*)(-r[0-9]+)?$";
- [[ ${va} =~ ${re} ]] || die "${FUNCNAME}: invalid version: ${va}";
- an=${BASH_REMATCH[1]};
- al=${BASH_REMATCH[3]};
- as=${BASH_REMATCH[4]};
- ar=${BASH_REMATCH[7]};
- [[ ${vb} =~ ${re} ]] || die "${FUNCNAME}: invalid version: ${vb}";
- bn=${BASH_REMATCH[1]};
- bl=${BASH_REMATCH[3]};
- bs=${BASH_REMATCH[4]};
- br=${BASH_REMATCH[7]};
- _ver_compare_int "${an%%.*}" "${bn%%.*}" || return;
- while [[ ${an} == *.* && ${bn} == *.* ]]; do
- an=${an#*.};
- bn=${bn#*.};
- a=${an%%.*};
- b=${bn%%.*};
- if [[ ${a} == 0* || ${b} == 0* ]]; then
- [[ ${a} =~ 0+$ ]] && a=${a%"${BASH_REMATCH[0]}"};
- [[ ${b} =~ 0+$ ]] && b=${b%"${BASH_REMATCH[0]}"};
- [[ ${a} > ${b} ]] && return 3;
- [[ ${a} < ${b} ]] && return 1;
- else
- _ver_compare_int "${a}" "${b}" || return;
- fi;
- done;
- [[ ${an} == *.* ]] && return 3;
- [[ ${bn} == *.* ]] && return 1;
- [[ ${al} > ${bl} ]] && return 3;
- [[ ${al} < ${bl} ]] && return 1;
- as=${as#_}${as:+_};
- bs=${bs#_}${bs:+_};
- while [[ -n ${as} && -n ${bs} ]]; do
- a=${as%%_*};
- b=${bs%%_*};
- if [[ ${a%%[0-9]*} == "${b%%[0-9]*}" ]]; then
- _ver_compare_int "${a##*[a-z]}" "${b##*[a-z]}" || return;
- else
- [[ ${a%%[0-9]*} == p ]] && return 3;
- [[ ${b%%[0-9]*} == p ]] && return 1;
- [[ ${a} > ${b} ]] && return 3 || return 1;
- fi;
- as=${as#*_};
- bs=${bs#*_};
- done;
- if [[ -n ${as} ]]; then
- [[ ${as} == p[_0-9]* ]] && return 3 || return 1;
- else
- if [[ -n ${bs} ]]; then
- [[ ${bs} == p[_0-9]* ]] && return 1 || return 3;
- fi;
- fi;
- _ver_compare_int "${ar#-r}" "${br#-r}" || return;
- return 2
- }
- _ver_compare_int ()
- {
- local a=$1 b=$2 d=$(( ${#1}-${#2} ));
- if [[ ${d} -gt 0 ]]; then
- printf -v b "%0${d}d%s" 0 "${b}";
- else
- if [[ ${d} -lt 0 ]]; then
- printf -v a "%0$(( -d ))d%s" 0 "${a}";
- fi;
- fi;
- [[ ${a} > ${b} ]] && return 3;
- [[ ${a} == "${b}" ]]
- }
- _ver_parse_range ()
- {
- local range=${1};
- local max=${2};
- [[ ${range} == [0-9]* ]] || die "${FUNCNAME}: range must start with a number";
- start=${range%-*};
- [[ ${range} == *-* ]] && end=${range#*-} || end=${start};
- if [[ -n ${end} ]]; then
- [[ ${start} -le ${end} ]] || die "${FUNCNAME}: end of range must be >= start";
- [[ ${end} -le ${max} ]] || end=${max};
- else
- end=${max};
- fi
- }
- _ver_split ()
- {
- local v=${1} LC_ALL=C;
- comp=();
- local s c;
- while [[ -n ${v} ]]; do
- s=${v%%[a-zA-Z0-9]*};
- v=${v:${#s}};
- [[ ${v} == [0-9]* ]] && c=${v%%[^0-9]*} || c=${v%%[^a-zA-Z]*};
- v=${v:${#c}};
- comp+=("${s}" "${c}");
- done
- }
- autotools_check_macro ()
- {
- [[ -f configure.ac || -f configure.in ]] || return 0;
- local trace_file=".__autoconf_trace_data";
- if [[ ! -e ${trace_file} ]] || [[ ! aclocal.m4 -ot ${trace_file} ]]; then
- WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) ${ALL_AUTOTOOLS_MACROS[@]/#/--trace=} > ${trace_file} 2> /dev/null;
- fi;
- local macro args=();
- for macro in "$@";
- do
- has ${macro} ${ALL_AUTOTOOLS_MACROS[@]} || die "internal error: add ${macro} to ALL_AUTOTOOLS_MACROS";
- args+=(-e ":${macro}:");
- done;
- grep "${args[@]}" ${trace_file}
- }
- autotools_check_macro_val ()
- {
- local macro scan_out;
- for macro in "$@";
- do
- autotools_check_macro "${macro}" | gawk -v macro="${macro}" '($0 !~ /^[[:space:]]*(#|dnl)/) {
- if (match($0, macro ":(.*)$", res))
- print res[1]
- }' | uniq;
- done;
- return 0
- }
- autotools_env_setup ()
- {
- if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
- local pv;
- for pv in ${_LATEST_AUTOMAKE[@]/#*:};
- do
- local hv_args="";
- case ${EAPI:-0} in
- 5 | 6)
- hv_args="--host-root"
- ;;
- 7)
- hv_args="-b"
- ;;
- esac;
- ROOT=/ has_version ${hv_args} "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}" && break;
- done;
- [[ ${WANT_AUTOMAKE} == "latest" ]] && die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE[*]}";
- fi;
- [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
- }
- autotools_m4dir_include ()
- {
- _autotools_m4dir_include ${AT_M4DIR}
- }
- autotools_m4sysdir_include ()
- {
- local paths=($(eval echo ${AT_SYS_M4DIR}));
- if [[ ${#paths[@]} -eq 0 && -n ${SYSROOT} ]]; then
- local path="${SYSROOT}/usr/share/aclocal";
- [[ -d ${path} ]] && paths+=("${path}");
- fi;
- _autotools_m4dir_include "${paths[@]}"
- }
- autotools_run_tool ()
- {
- local autofail=true m4flags=false missing_ok=false return_output=false;
- while [[ -n $1 ]]; do
- case $1 in
- --at-no-fail)
- autofail=false
- ;;
- --at-m4flags)
- m4flags=true
- ;;
- --at-missing)
- missing_ok=true
- ;;
- --at-output)
- return_output=true
- ;;
- *)
- break
- ;;
- esac;
- shift;
- done;
- if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
- ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase";
- fi;
- if ${missing_ok} && ! type -P ${1} > /dev/null; then
- einfo "Skipping '$*' due $1 not installed";
- return 0;
- fi;
- autotools_env_setup;
- local STDERR_TARGET="${T}/${1##*/}.out";
- if [[ -e ${STDERR_TARGET} ]]; then
- local i=1;
- while :; do
- STDERR_TARGET="${T}/${1##*/}-${i}.out";
- [[ -e ${STDERR_TARGET} ]] || break;
- : $(( i++ ));
- done;
- fi;
- if ${m4flags}; then
- set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include);
- fi;
- if ${return_output}; then
- "$@";
- return;
- fi;
- printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}";
- ebegin "Running $@";
- "$@" >> "${STDERR_TARGET}" 2>&1;
- if ! eend $? && ${autofail}; then
- echo;
- eerror "Failed Running $1 !";
- eerror;
- eerror "Include in your bugreport the contents of:";
- eerror;
- eerror " ${STDERR_TARGET}";
- echo;
- die "Failed Running $1 !";
- fi
- }
- clang-fullversion ()
- {
- _clang_fullversion '$1.$2.$3' "$@"
- }
- clang-major-version ()
- {
- _clang_fullversion '$1' "$@"
- }
- clang-micro-version ()
- {
- _clang_fullversion '$3' "$@"
- }
- clang-minor-version ()
- {
- _clang_fullversion '$2' "$@"
- }
- clang-version ()
- {
- _clang_fullversion '$1.$2' "$@"
- }
- config_rpath_update ()
- {
- local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:');
- [[ $# -eq 0 ]] && set -- $(find -name config.rpath);
- [[ $# -eq 0 ]] && return 0;
- einfo "Updating all config.rpath files";
- for dst in "$@";
- do
- einfo " ${dst}";
- cp "${src}" "${dst}" || die;
- done
- }
- darwintoolize ()
- {
- die "Use elibtoolize"
- }
- db_findver ()
- {
- has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=;
- if [ $# -ne 1 ]; then
- eerror "Function db_findver needs one argument" 1>&2;
- eerror "args given:" 1>&2;
- for f in $@;
- do
- eerror " - \"$@\"" 1>&2;
- done;
- return 1;
- fi;
- PKG="$(best_version $1)";
- VER="$(ver_cut 1-2 "${PKG/*db-/}")";
- if [ -d "${EPREFIX}"/usr/include/db$(db_ver_to_slot "$VER") ]; then
- echo -n "$VER";
- return 0;
- else
- return 1;
- fi
- }
- db_includedir ()
- {
- has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=;
- if [ $# -eq 0 ]; then
- VER="$(db_findver sys-libs/db)" || return 1;
- VER="$(db_ver_to_slot "$VER")";
- echo "include version ${VER}" 1>&2;
- if [ -d "${EPREFIX}/usr/include/db${VER}" ]; then
- echo -n "${EPREFIX}/usr/include/db${VER}";
- return 0;
- else
- eerror "sys-libs/db package requested, but headers not found" 1>&2;
- return 1;
- fi;
- else
- for x in $@;
- do
- if VER=$(db_findver "=sys-libs/db-${x}*") && [ -d "${EPREFIX}/usr/include/db$(db_ver_to_slot $VER)" ]; then
- echo -n "${EPREFIX}/usr/include/db$(db_ver_to_slot $VER)";
- return 0;
- fi;
- done;
- eerror "No suitable db version found";
- return 1;
- fi
- }
- db_libname ()
- {
- has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=;
- if [ $# -eq 0 ]; then
- VER="$(db_findver sys-libs/db)" || return 1;
- if [ -e "${EPREFIX}/usr/$(get_libdir)/libdb-${VER}$(get_libname)" ]; then
- echo -n "db-${VER}";
- return 0;
- else
- eerror "sys-libs/db package requested, but library not found" 1>&2;
- return 1;
- fi;
- else
- for x in $@;
- do
- if VER=$(db_findver "=sys-libs/db-${x}*"); then
- if [ -e "${EPREFIX}/usr/$(get_libdir)/libdb-${VER}$(get_libname)" ]; then
- echo -n "db-${VER}";
- return 0;
- fi;
- fi;
- done;
- eerror "No suitable db version found" 1>&2;
- return 1;
- fi
- }
- db_ver_to_slot ()
- {
- if [ $# -ne 1 ]; then
- eerror "Function db_ver_to_slot needs one argument" 1>&2;
- eerror "args given:" 1>&2;
- for f in $@;
- do
- eerror " - \"$@\"" 1>&2;
- done;
- return 1;
- fi;
- echo -n "$1"
- }
- eaclocal ()
- {
- [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
- }
- eaclocal_amflags ()
- {
- local aclocal_opts amflags_file;
- for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in;
- do
- [[ -e ${amflags_file} ]] || continue;
- autotools_env_setup;
- aclocal_opts=$(sed -n "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ # match the first line
- s:[^=]*=::p; # then gobble up all escaped lines
- : nextline /\\\\$/{ n; p; b nextline; } }" ${amflags_file});
- eval aclocal_opts=\""${aclocal_opts}"\";
- break;
- done;
- echo ${aclocal_opts}
- }
- eapply ()
- {
- local failed patch_cmd=patch;
- local -x LC_COLLATE=POSIX;
- type -P gpatch > /dev/null && patch_cmd=gpatch;
- function _eapply_patch ()
- {
- local f=${1};
- local prefix=${2};
- started_applying=1;
- ebegin "${prefix:-Applying }${f##*/}";
- ${patch_cmd} -p1 -f -s -g0 --no-backup-if-mismatch "${patch_options[@]}" < "${f}";
- failed=${?};
- if ! eend "${failed}"; then
- __helpers_die "patch -p1 ${patch_options[*]} failed with ${f}";
- fi
- };
- local patch_options=() files=();
- local i found_doublehyphen;
- for ((i = 1; i <= ${#@}; ++i ))
- do
- if [[ ${@:i:1} == -- ]]; then
- patch_options=("${@:1:i-1}");
- files=("${@:i+1}");
- found_doublehyphen=1;
- break;
- fi;
- done;
- if [[ -z ${found_doublehyphen} ]]; then
- for ((i = 1; i <= ${#@}; ++i ))
- do
- if [[ ${@:i:1} != -* ]]; then
- patch_options=("${@:1:i-1}");
- files=("${@:i}");
- break;
- fi;
- done;
- for i in "${files[@]}";
- do
- if [[ ${i} == -* ]]; then
- die "eapply: all options must be passed before non-options";
- fi;
- done;
- fi;
- if [[ ${#files[@]} -eq 0 ]]; then
- die "eapply: no files specified";
- fi;
- local f;
- for f in "${files[@]}";
- do
- if [[ -d ${f} ]]; then
- function _eapply_get_files ()
- {
- local LC_ALL=POSIX;
- local prev_shopt=$(shopt -p nullglob);
- shopt -s nullglob;
- local f;
- for f in "${1}"/*;
- do
- if [[ ${f} == *.diff || ${f} == *.patch ]]; then
- files+=("${f}");
- fi;
- done;
- ${prev_shopt}
- };
- local files=();
- _eapply_get_files "${f}";
- [[ ${#files[@]} -eq 0 ]] && die "No *.{patch,diff} files in directory ${f}";
- einfo "Applying patches from ${f} ...";
- local f2;
- for f2 in "${files[@]}";
- do
- _eapply_patch "${f2}" ' ';
- [[ ${failed} -ne 0 ]] && return "${failed}";
- done;
- else
- _eapply_patch "${f}";
- [[ ${failed} -ne 0 ]] && return "${failed}";
- fi;
- done;
- return 0
- }
- eapply_user ()
- {
- [[ ${EBUILD_PHASE} == prepare ]] || die "eapply_user() called during invalid phase: ${EBUILD_PHASE}";
- local tagfile=${T}/.portage_user_patches_applied;
- [[ -f ${tagfile} ]] && return;
- >> "${tagfile}";
- local basedir=${PORTAGE_CONFIGROOT%/}/etc/portage/patches;
- local applied d f;
- local -A _eapply_user_patches;
- local prev_shopt=$(shopt -p nullglob);
- shopt -s nullglob;
- for d in "${basedir}"/${CATEGORY}/{${P}-${PR},${P},${PN}}{:${SLOT%/*},};
- do
- for f in "${d}"/*;
- do
- if [[ ( ${f} == *.diff || ${f} == *.patch ) && -z ${_eapply_user_patches[${f##*/}]} ]]; then
- _eapply_user_patches[${f##*/}]=${f};
- fi;
- done;
- done;
- if [[ ${#_eapply_user_patches[@]} -gt 0 ]]; then
- while read -r -d '' f; do
- f=${_eapply_user_patches[${f}]};
- if [[ -s ${f} ]]; then
- eapply "${f}";
- applied=1;
- fi;
- done < <(printf -- '%s\0' "${!_eapply_user_patches[@]}" |
- LC_ALL=C sort -z);
- fi;
- ${prev_shopt};
- [[ -n ${applied} ]] && ewarn "User patches applied."
- }
- eautoconf ()
- {
- if [[ ! -f configure.ac && ! -f configure.in ]]; then
- echo;
- eerror "No configure.{ac,in} present in '${PWD}'!";
- echo;
- die "No configure.{ac,in} present!";
- fi;
- if [[ ${WANT_AUTOCONF} != "2.1" && -e configure.in ]]; then
- eqawarn "This package has a configure.in file which has long been deprecated. Please";
- eqawarn "update it to use configure.ac instead as newer versions of autotools will die";
- eqawarn "when it finds this file. See https://bugs.gentoo.org/426262 for details.";
- fi;
- autotools_run_tool --at-m4flags autoconf "$@"
- }
- eautoheader ()
- {
- _at_uses_autoheader || return 0;
- autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
- }
- eautomake ()
- {
- local extra_opts=();
- local makefile_name;
- for makefile_name in {GNUmakefile,{M,m}akefile}.am "";
- do
- [[ -f ${makefile_name} ]] && break;
- done;
- function _automake_version ()
- {
- autotools_run_tool --at-output automake --version 2> /dev/null | sed -n -e '1{s:.*(GNU automake) ::p;q}'
- };
- if [[ -z ${makefile_name} ]]; then
- _at_uses_automake || return 0;
- else
- if [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
- local used_automake;
- local installed_automake;
- installed_automake=$(WANT_AUTOMAKE= _automake_version);
- used_automake=$(head -n 1 < ${makefile_name%.am}.in | sed -e 's:.*by automake \(.*\) from .*:\1:');
- if [[ ${installed_automake} != ${used_automake} ]]; then
- ewarn "Automake used for the package (${used_automake}) differs from" "the installed version (${installed_automake}).";
- ewarn "Forcing a full rebuild of the autotools to workaround.";
- eautoreconf;
- return 0;
- fi;
- fi;
- fi;
- [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] || extra_opts+=(--foreign);
- case $(_automake_version) in
- 1.4 | 1.4[.-]*)
-
- ;;
- *)
- extra_opts+=(--force-missing)
- ;;
- esac;
- autotools_run_tool automake --add-missing --copy "${extra_opts[@]}" "$@"
- }
- eautopoint ()
- {
- autotools_run_tool autopoint "$@"
- }
- eautoreconf ()
- {
- local x g;
- if [[ -z ${AT_NO_RECURSIVE} ]]; then
- for x in $(autotools_check_macro_val AC_CONFIG_SUBDIRS);
- do
- if [[ -d ${x} ]]; then
- pushd "${x}" > /dev/null;
- AT_NOELIBTOOLIZE="yes" eautoreconf || die;
- popd > /dev/null;
- fi;
- done;
- fi;
- einfo "Running eautoreconf in '${PWD}' ...";
- local m4dirs=$(autotools_check_macro_val AC_CONFIG_{AUX,MACRO}_DIR);
- [[ -n ${m4dirs} ]] && mkdir -p ${m4dirs};
- local i tools=(glibgettext false "autotools_run_tool glib-gettextize --copy --force" gettext false "autotools_run_tool --at-missing autopoint --force" intltool false "autotools_run_tool intltoolize --automake --copy --force" gtkdoc false "autotools_run_tool --at-missing gtkdocize --copy" gnomedoc false "autotools_run_tool --at-missing gnome-doc-prepare --copy --force" libtool false "_elibtoolize --auto-ltdl --install --copy --force");
- for ((i = 0; i < ${#tools[@]}; i += 3 ))
- do
- if _at_uses_${tools[i]}; then
- tools[i+1]=true;
- ${tools[i+2]};
- fi;
- done;
- local rerun_aclocal=false;
- eaclocal;
- for ((i = 0; i < ${#tools[@]}; i += 3 ))
- do
- if ! ${tools[i+1]} && _at_uses_${tools[i]}; then
- ${tools[i+2]};
- rerun_aclocal=true;
- fi;
- done;
- ${rerun_aclocal} && eaclocal;
- if [[ ${WANT_AUTOCONF} = 2.1 ]]; then
- eautoconf;
- else
- eautoconf --force;
- fi;
- eautoheader;
- [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS};
- if [[ ${AT_NOELIBTOOLIZE} != "yes" ]]; then
- elibtoolize --force "${PWD}";
- fi;
- return 0
- }
- econf_build ()
- {
- local CBUILD=${CBUILD:-${CHOST}};
- tc-env_build econf --build=${CBUILD} --host=${CBUILD} "$@"
- }
- einstalldocs ()
- {
- ( if ! declare -p DOCS &> /dev/null; then
- local d;
- for d in README* ChangeLog AUTHORS NEWS TODO CHANGES THANKS BUGS FAQ CREDITS CHANGELOG;
- do
- [[ -f ${d} && -s ${d} ]] && docinto / && dodoc "${d}";
- done;
- else
- if [[ $(declare -p DOCS) == "declare -a"* ]]; then
- [[ ${#DOCS[@]} -gt 0 ]] && docinto / && dodoc -r "${DOCS[@]}";
- else
- [[ -n ${DOCS} ]] && docinto / && dodoc -r ${DOCS};
- fi;
- fi );
- ( if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]]; then
- [[ ${#HTML_DOCS[@]} -gt 0 ]] && docinto html && dodoc -r "${HTML_DOCS[@]}";
- else
- [[ -n ${HTML_DOCS} ]] && docinto html && dodoc -r ${HTML_DOCS};
- fi )
- }
- elibtoolize ()
- {
- type -P eltpatch &> /dev/null || die "eltpatch not found; is app-portage/elt-patches installed?";
- ELT_LOGDIR=${T} LD=$(tc-getLD) eltpatch "${@}" || die "eltpatch failed"
- }
- fcaps ()
- {
- debug-print-function ${FUNCNAME} "$@";
- local owner='root';
- local group='0';
- local mode='4711';
- local caps_mode='711';
- while [[ $# -gt 0 ]]; do
- case $1 in
- -o)
- owner=$2;
- shift
- ;;
- -g)
- group=$2;
- shift
- ;;
- -m)
- mode=$2;
- shift
- ;;
- -M)
- caps_mode=$2;
- shift
- ;;
- *)
- break
- ;;
- esac;
- shift;
- done;
- [[ $# -lt 2 ]] && die "${FUNCNAME}: wrong arg count";
- local caps=$1;
- [[ ${caps} == *[-=+]* ]] || caps+="=ep";
- shift;
- local root;
- case ${EBUILD_PHASE} in
- compile | install | preinst)
- root=${ED:-${D}}
- ;;
- postinst)
- root=${EROOT:-${ROOT}}
- ;;
- esac;
- root=${root%/};
- local file;
- for file in "$@";
- do
- [[ ${file} != /* ]] && file="${root}/${file}";
- if use filecaps; then
- debug-print "${FUNCNAME}: setting caps '${caps}' on '${file}'";
- chmod ${caps_mode} "${file}" || die;
- function _libcap ()
- {
- setcap "${caps}" "${file}"
- };
- function _libcap_verify ()
- {
- setcap -v "${caps}" "${file}" > /dev/null
- };
- function _libcap_ng ()
- {
- local caps=",${caps%=ep}";
- filecap "${file}" "${caps//,cap_}"
- };
- function _libcap_ng_verify ()
- {
- local rcaps icaps caps=",${caps%=ep}";
- rcaps=$(filecap "${file}" | sed -nr -e "s:^.{${#file}} +::" -e 's:, +:\n:g' -e 2p | LC_ALL=C sort);
- [[ ${PIPESTATUS[0]} -eq 0 ]] || return 1;
- icaps=$(echo "${caps//,cap_}" | LC_ALL=C sort);
- [[ ${rcaps} == ${icaps} ]]
- };
- local out cmd notfound=0;
- for cmd in _libcap _libcap_ng;
- do
- if ! out=$(LC_ALL=C ${cmd} 2>&1); then
- case ${out} in
- *"command not found"*)
- : $(( ++notfound ));
- continue
- ;;
- *"Not supported"* | *"Operation not supported"*)
- local fstype=$(stat -f -c %T "${file}");
- ewarn "Could not set caps on '${file}' due to missing filesystem support:";
- ewarn "* enable XATTR support for '${fstype}' in your kernel (if configurable)";
- ewarn "* mount the fs with the user_xattr option (if not the default)";
- ewarn "* enable the relevant FS_SECURITY option (if configurable)";
- break
- ;;
- *)
- eerror "Setting caps '${caps}' on file '${file}' failed:";
- eerror "${out}";
- die "could not set caps"
- ;;
- esac;
- else
- ${cmd}_verify || die "Checking caps '${caps}' on '${file}' failed";
- continue 2;
- fi;
- done;
- if [[ ${notfound} -eq 2 ]] && [[ -z ${_FCAPS_WARNED} ]]; then
- _FCAPS_WARNED="true";
- ewarn "Could not find cap utils; make sure libcap or libcap-ng is available.";
- fi;
- fi;
- debug-print "${FUNCNAME}: setting owner/mode on '${file}'";
- chown "${owner}:${group}" "${file}" || die;
- chmod ${mode} "${file}" || die;
- done
- }
- fcaps_pkg_postinst ()
- {
- local arg args=();
- for arg in "${FILECAPS[@]}" "--";
- do
- if [[ ${arg} == "--" ]]; then
- fcaps "${args[@]}";
- args=();
- else
- args+=("${arg}");
- fi;
- done
- }
- gcc-fullversion ()
- {
- _gcc_fullversion '$1.$2.$3' "$@"
- }
- gcc-major-version ()
- {
- _gcc_fullversion '$1' "$@"
- }
- gcc-micro-version ()
- {
- _gcc_fullversion '$3' "$@"
- }
- gcc-minor-version ()
- {
- _gcc_fullversion '$2' "$@"
- }
- gcc-specs-directive ()
- {
- local directive subdname subdirective;
- directive="$(_gcc-specs-directive_raw $1)";
- while [[ ${directive} == *%\(*\)* ]]; do
- subdname=${directive/*%\(};
- subdname=${subdname/\)*};
- subdirective="$(_gcc-specs-directive_raw ${subdname})";
- directive="${directive//\%(${subdname})/${subdirective}}";
- done;
- echo "${directive}";
- return 0
- }
- gcc-specs-nostrict ()
- {
- local directive;
- directive=$(gcc-specs-directive cc1);
- [[ "${directive/\{!fstrict-overflow:}" != "${directive}" ]]
- }
- gcc-specs-now ()
- {
- local directive;
- directive=$(gcc-specs-directive link_command);
- [[ "${directive/\{!nonow:}" != "${directive}" ]]
- }
- gcc-specs-pie ()
- {
- local directive;
- directive=$(gcc-specs-directive cc1);
- [[ "${directive/\{!nopie:}" != "${directive}" ]]
- }
- gcc-specs-relro ()
- {
- local directive;
- directive=$(gcc-specs-directive link_command);
- [[ "${directive/\{!norelro:}" != "${directive}" ]]
- }
- gcc-specs-ssp ()
- {
- local directive;
- directive=$(gcc-specs-directive cc1);
- [[ "${directive/\{!fno-stack-protector:}" != "${directive}" ]]
- }
- gcc-specs-ssp-to-all ()
- {
- local directive;
- directive=$(gcc-specs-directive cc1);
- [[ "${directive/\{!fno-stack-protector-all:}" != "${directive}" ]]
- }
- gcc-specs-stack-check ()
- {
- local directive;
- directive=$(gcc-specs-directive cc1);
- [[ "${directive/\{!fno-stack-check:}" != "${directive}" ]]
- }
- gcc-version ()
- {
- _gcc_fullversion '$1.$2' "$@"
- }
- gen_usr_ldscript ()
- {
- local lib libdir=$(get_libdir) output_format="" auto=false suffix=$(get_libname);
- [[ -z ${ED+set} ]] && local ED=${D%/}${EPREFIX}/;
- tc-is-static-only && return;
- if [[ $(type -t multilib_is_native_abi) == "function" ]]; then
- multilib_is_native_abi || return 0;
- fi;
- case ${CTARGET:-${CHOST}} in
- *-darwin*)
-
- ;;
- *-android*)
- return 0
- ;;
- *linux* | *-freebsd* | *-openbsd* | *-netbsd*)
- use prefix && return 0
- ;;
- *)
- return 0
- ;;
- esac;
- dodir /usr/${libdir};
- if [[ $1 == "-a" ]]; then
- auto=true;
- shift;
- dodir /${libdir};
- fi;
- local flags=(${CFLAGS} ${LDFLAGS} -Wl,--verbose);
- if $(tc-getLD) --version | grep -q 'GNU gold'; then
- local d="${T}/bfd-linker";
- mkdir -p "${d}";
- ln -sf $(which ${CHOST}-ld.bfd) "${d}"/ld;
- flags+=(-B"${d}");
- fi;
- output_format=$($(tc-getCC) "${flags[@]}" 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p');
- [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )";
- for lib in "$@";
- do
- local tlib;
- if ${auto}; then
- lib="lib${lib}${suffix}";
- else
- [[ -r ${ED}/${libdir}/${lib} ]] || continue;
- fi;
- case ${CTARGET:-${CHOST}} in
- *-darwin*)
- if ${auto}; then
- tlib=$(scanmacho -qF'%S#F' "${ED}"/usr/${libdir}/${lib});
- else
- tlib=$(scanmacho -qF'%S#F' "${ED}"/${libdir}/${lib});
- fi;
- [[ -z ${tlib} ]] && die "unable to read install_name from ${lib}";
- tlib=${tlib##*/};
- if ${auto}; then
- mv "${ED}"/usr/${libdir}/${lib%${suffix}}.*${suffix#.} "${ED}"/${libdir}/ || die;
- if [[ ${tlib} != ${lib%${suffix}}.*${suffix#.} ]]; then
- mv "${ED}"/usr/${libdir}/${tlib%${suffix}}.*${suffix#.} "${ED}"/${libdir}/ || die;
- fi;
- rm -f "${ED}"/${libdir}/${lib};
- fi;
- if [[ ! -w "${ED}/${libdir}/${tlib}" ]]; then
- chmod u+w "${ED}${libdir}/${tlib}";
- local nowrite=yes;
- fi;
- install_name_tool -id "${EPREFIX}"/${libdir}/${tlib} "${ED}"/${libdir}/${tlib} || die "install_name_tool failed";
- [[ -n ${nowrite} ]] && chmod u-w "${ED}${libdir}/${tlib}";
- pushd "${ED}/usr/${libdir}" > /dev/null;
- ln -snf "../../${libdir}/${tlib}" "${lib}";
- popd > /dev/null
- ;;
- *)
- if ${auto}; then
- tlib=$(scanelf -qF'%S#F' "${ED}"/usr/${libdir}/${lib});
- [[ -z ${tlib} ]] && die "unable to read SONAME from ${lib}";
- mv "${ED}"/usr/${libdir}/${lib}* "${ED}"/${libdir}/ || die;
- if [[ ${tlib} != ${lib}* ]]; then
- mv "${ED}"/usr/${libdir}/${tlib}* "${ED}"/${libdir}/ || die;
- fi;
- rm -f "${ED}"/${libdir}/${lib};
- else
- tlib=${lib};
- fi;
- cat > "${ED}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
- /* GNU ld script
- Since Gentoo has critical dynamic libraries in /lib, and the static versions
- in /usr/lib, we need to have a "fake" dynamic lib in /usr/lib, otherwise we
- run into linking problems. This "fake" dynamic lib is a linker script that
- redirects the linker to the real lib. And yes, this works in the cross-
- compiling scenario as the sysroot-ed linker will prepend the real path.
-
- See bug https://bugs.gentoo.org/4411 for more info.
- */
- ${output_format}
- GROUP ( ${EPREFIX}/${libdir}/${tlib} )
- END_LDSCRIPT
-
- ;;
- esac
- fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}";
- done
- }
- get_abi_CFLAGS ()
- {
- get_abi_var CFLAGS "$@"
- }
- get_abi_CHOST ()
- {
- get_abi_var CHOST "$@"
- }
- get_abi_CTARGET ()
- {
- get_abi_var CTARGET "$@"
- }
- get_abi_FAKE_TARGETS ()
- {
- get_abi_var FAKE_TARGETS "$@"
- }
- get_abi_LDFLAGS ()
- {
- get_abi_var LDFLAGS "$@"
- }
- get_abi_LIBDIR ()
- {
- get_abi_var LIBDIR "$@"
- }
- get_abi_var ()
- {
- local flag=$1;
- local abi=${2:-${ABI:-${DEFAULT_ABI:-default}}};
- local var="${flag}_${abi}";
- echo ${!var}
- }
- get_all_abis ()
- {
- local x order="" mvar dvar;
- mvar="MULTILIB_ABIS";
- dvar="DEFAULT_ABI";
- if [[ -n $1 ]]; then
- mvar="$1_${mvar}";
- dvar="$1_${dvar}";
- fi;
- if [[ -z ${!mvar} ]]; then
- echo "default";
- return 0;
- fi;
- for x in ${!mvar};
- do
- if [[ ${x} != ${!dvar} ]]; then
- order="${order:+${order} }${x}";
- fi;
- done;
- order="${order:+${order} }${!dvar}";
- echo ${order};
- return 0
- }
- get_all_libdirs ()
- {
- local libdirs abi;
- for abi in ${MULTILIB_ABIS};
- do
- libdirs+=" $(get_abi_LIBDIR ${abi})";
- done;
- [[ " ${libdirs} " != *" lib "* ]] && libdirs+=" lib";
- echo "${libdirs}"
- }
- get_exeext ()
- {
- case ${CHOST} in
- *-cygwin* | mingw* | *-mingw*)
- echo ".exe"
- ;;
- esac
- }
- get_install_abis ()
- {
- local x order="";
- if [[ -z ${MULTILIB_ABIS} ]]; then
- echo "default";
- return 0;
- fi;
- if [[ ${EMULTILIB_PKG} == "true" ]]; then
- for x in ${MULTILIB_ABIS};
- do
- if [[ ${x} != "${DEFAULT_ABI}" ]]; then
- has ${x} ${ABI_DENY} || order="${order} ${x}";
- fi;
- done;
- has ${DEFAULT_ABI} ${ABI_DENY} || order="${order} ${DEFAULT_ABI}";
- if [[ -n ${ABI_ALLOW} ]]; then
- local ordera="";
- for x in ${order};
- do
- if has ${x} ${ABI_ALLOW}; then
- ordera="${ordera} ${x}";
- fi;
- done;
- order=${ordera};
- fi;
- else
- order=${DEFAULT_ABI};
- fi;
- if [[ -z ${order} ]]; then
- die "The ABI list is empty. Are you using a proper multilib profile? Perhaps your USE flags or MULTILIB_ABIS are too restrictive for this package.";
- fi;
- echo ${order};
- return 0
- }
- get_libdir ()
- {
- local libdir_var="LIBDIR_${ABI}";
- local libdir="lib";
- [[ -n ${ABI} && -n ${!libdir_var} ]] && libdir=${!libdir_var};
- echo "${libdir}"
- }
- get_libname ()
- {
- local libname;
- local ver=$1;
- case ${CHOST} in
- *-cygwin*)
- libname="dll.a"
- ;;
- mingw* | *-mingw*)
- libname="dll"
- ;;
- *-darwin*)
- libname="dylib"
- ;;
- *-mint*)
- libname="irrelevant"
- ;;
- hppa*-hpux*)
- libname="sl"
- ;;
- *)
- libname="so"
- ;;
- esac;
- if [[ -z $* ]]; then
- echo ".${libname}";
- else
- for ver in "$@";
- do
- case ${CHOST} in
- *-cygwin*)
- echo ".${ver}.${libname}"
- ;;
- *-darwin*)
- echo ".${ver}.${libname}"
- ;;
- *-mint*)
- echo ".${libname}"
- ;;
- *)
- echo ".${libname}.${ver}"
- ;;
- esac;
- done;
- fi
- }
- get_modname ()
- {
- local modname;
- local ver=$1;
- case ${CHOST} in
- *-darwin*)
- modname="bundle"
- ;;
- *)
- modname="so"
- ;;
- esac;
- echo ".${modname}"
- }
- has_multilib_profile ()
- {
- [ -n "${MULTILIB_ABIS}" -a "${MULTILIB_ABIS}" != "${MULTILIB_ABIS/ /}" ]
- }
- in_iuse ()
- {
- local use=${1};
- if [[ -z "${use}" ]]; then
- echo "!!! in_iuse() called without a parameter." 1>&2;
- echo "!!! in_iuse <USEFLAG>" 1>&2;
- die "in_iuse() called without a parameter";
- fi;
- local liuse=(${IUSE_EFFECTIVE});
- has "${use}" "${liuse[@]#[+-]}"
- }
- is_final_abi ()
- {
- has_multilib_profile || return 0;
- set -- $(get_install_abis);
- local LAST_ABI=$#;
- [[ ${!LAST_ABI} == ${ABI} ]]
- }
- multibuild_copy_sources ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local _MULTIBUILD_INITIAL_BUILD_DIR=${BUILD_DIR:-${S}};
- einfo "Will copy sources from ${_MULTIBUILD_INITIAL_BUILD_DIR}";
- local cp_args=();
- if cp --reflink=auto --version &> /dev/null; then
- cp_args+=(--reflink=auto);
- fi;
- function _multibuild_create_source_copy ()
- {
- einfo "${MULTIBUILD_VARIANT}: copying to ${BUILD_DIR}";
- cp -p -R "${cp_args[@]}" "${_MULTIBUILD_INITIAL_BUILD_DIR}" "${BUILD_DIR}" || die
- };
- multibuild_foreach_variant _multibuild_create_source_copy
- }
- multibuild_for_best_variant ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ -n ${MULTIBUILD_VARIANTS} ]] || die "MULTIBUILD_VARIANTS need to be set";
- local MULTIBUILD_VARIANTS=("${MULTIBUILD_VARIANTS[$(( ${#MULTIBUILD_VARIANTS[@]} - 1 ))]}");
- multibuild_foreach_variant "${@}"
- }
- multibuild_foreach_variant ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ -n ${MULTIBUILD_VARIANTS} ]] || die "MULTIBUILD_VARIANTS need to be set";
- local bdir=${BUILD_DIR:-${S}};
- [[ ${bdir%%/} == ${WORKDIR%%/} ]] && bdir=${WORKDIR}/build;
- local prev_id=${MULTIBUILD_ID:+${MULTIBUILD_ID}-};
- local ret=0 lret=0 v;
- debug-print "${FUNCNAME}: initial build_dir = ${bdir}";
- for v in "${MULTIBUILD_VARIANTS[@]}";
- do
- local MULTIBUILD_VARIANT=${v};
- local MULTIBUILD_ID=${prev_id}${v};
- local BUILD_DIR=${bdir%%/}-${v};
- function _multibuild_run ()
- {
- local i=1;
- while [[ ${!i} == _* ]]; do
- (( i += 1 ));
- done;
- [[ ${i} -le ${#} ]] && einfo "${v}: running ${@:${i}}";
- "${@}"
- };
- _multibuild_run "${@}" > >(exec tee -a "${T}/build-${MULTIBUILD_ID}.log") 2>&1;
- lret=${?};
- done;
- [[ ${ret} -eq 0 && ${lret} -ne 0 ]] && ret=${lret};
- return ${ret}
- }
- multibuild_merge_root ()
- {
- local src=${1};
- local dest=${2};
- local ret;
- if use userland_BSD; then
- tar -C "${src}" -f - -c . | tar -x -f - -C "${dest}";
- [[ ${PIPESTATUS[*]} == '0 0' ]];
- ret=${?};
- else
- local cp_args=();
- if cp -a --version &> /dev/null; then
- cp_args+=(-a);
- else
- cp_args+=(-P -R -p);
- fi;
- if cp --reflink=auto --version &> /dev/null; then
- cp_args+=(--reflink=auto);
- fi;
- cp "${cp_args[@]}" "${src}"/. "${dest}"/;
- ret=${?};
- fi;
- if [[ ${ret} -ne 0 ]]; then
- die "${MULTIBUILD_VARIANT:-(unknown)}: merging image failed.";
- fi;
- rm -rf "${src}"
- }
- multibuild_parallel_foreach_variant ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ ${EAPI} == [45] ]] || die "${FUNCNAME} is banned in EAPI ${EAPI}";
- multibuild_foreach_variant "${@}"
- }
- multilib-minimal_abi_src_configure ()
- {
- debug-print-function ${FUNCNAME} "$@";
- mkdir -p "${BUILD_DIR}" || die;
- pushd "${BUILD_DIR}" > /dev/null || die;
- if declare -f multilib_src_configure > /dev/null; then
- multilib_src_configure;
- else
- default_src_configure;
- fi;
- popd > /dev/null || die
- }
- multilib-minimal_src_compile ()
- {
- debug-print-function ${FUNCNAME} "$@";
- function multilib-minimal_abi_src_compile ()
- {
- debug-print-function ${FUNCNAME} "$@";
- pushd "${BUILD_DIR}" > /dev/null || die;
- if declare -f multilib_src_compile > /dev/null; then
- multilib_src_compile;
- else
- default_src_compile;
- fi;
- popd > /dev/null || die
- };
- multilib_foreach_abi multilib-minimal_abi_src_compile
- }
- multilib-minimal_src_configure ()
- {
- debug-print-function ${FUNCNAME} "$@";
- function multilib-minimal_abi_src_configure ()
- {
- debug-print-function ${FUNCNAME} "$@";
- mkdir -p "${BUILD_DIR}" || die;
- pushd "${BUILD_DIR}" > /dev/null || die;
- if declare -f multilib_src_configure > /dev/null; then
- multilib_src_configure;
- else
- default_src_configure;
- fi;
- popd > /dev/null || die
- };
- multilib_foreach_abi multilib-minimal_abi_src_configure
- }
- multilib-minimal_src_install ()
- {
- debug-print-function ${FUNCNAME} "$@";
- function multilib-minimal_abi_src_install ()
- {
- debug-print-function ${FUNCNAME} "$@";
- pushd "${BUILD_DIR}" > /dev/null || die;
- if declare -f multilib_src_install > /dev/null; then
- multilib_src_install;
- else
- if [[ -f Makefile || -f GNUmakefile || -f makefile ]]; then
- emake DESTDIR="${D}" install;
- fi;
- fi;
- multilib_prepare_wrappers;
- multilib_check_headers;
- popd > /dev/null || die
- };
- multilib_foreach_abi multilib-minimal_abi_src_install;
- multilib_install_wrappers;
- if declare -f multilib_src_install_all > /dev/null; then
- multilib_src_install_all;
- else
- einstalldocs;
- fi
- }
- multilib-minimal_src_test ()
- {
- debug-print-function ${FUNCNAME} "$@";
- function multilib-minimal_abi_src_test ()
- {
- debug-print-function ${FUNCNAME} "$@";
- pushd "${BUILD_DIR}" > /dev/null || die;
- if declare -f multilib_src_test > /dev/null; then
- multilib_src_test;
- else
- default_src_test;
- fi;
- popd > /dev/null || die
- };
- multilib_foreach_abi multilib-minimal_abi_src_test
- }
- multilib_build_binaries ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ ${EAPI} == [45] ]] || die "${FUNCNAME} is banned in EAPI ${EAPI}, use multilib_is_native_abi() instead";
- eqawarn "QA warning: multilib_build_binaries is deprecated. Please use the equivalent";
- eqawarn "multilib_is_native_abi function instead.";
- multilib_is_native_abi "${@}"
- }
- multilib_check_headers ()
- {
- function _multilib_header_cksum ()
- {
- set -o pipefail;
- if [[ -d ${ED%/}/usr/include ]]; then
- find "${ED%/}"/usr/include -type f -exec cksum {} + | sort -k2;
- fi
- };
- local cksum cksum_prev;
- local cksum_file=${T}/.multilib_header_cksum;
- cksum=$(_multilib_header_cksum) || die;
- unset -f _multilib_header_cksum;
- if [[ -f ${cksum_file} ]]; then
- cksum_prev=$(< "${cksum_file}") || die;
- if [[ ${cksum} != ${cksum_prev} ]]; then
- echo "${cksum}" > "${cksum_file}.new" || die;
- eerror "Header files have changed between ABIs.";
- if type -p diff &> /dev/null; then
- eerror "$(diff -du "${cksum_file}" "${cksum_file}.new")";
- else
- eerror "Old checksums in: ${cksum_file}";
- eerror "New checksums in: ${cksum_file}.new";
- fi;
- die "Header checksum mismatch, aborting.";
- fi;
- else
- echo "${cksum}" > "${cksum_file}" || die;
- fi
- }
- multilib_copy_sources ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local MULTIBUILD_VARIANTS=($(multilib_get_enabled_abi_pairs));
- multibuild_copy_sources
- }
- multilib_env ()
- {
- local CTARGET=${1:-${CTARGET}};
- local cpu=${CTARGET%%*-};
- case ${cpu} in
- aarch64*)
- export CFLAGS_arm=${CFLAGS_arm-};
- case ${cpu} in
- aarch64*be)
- export CHOST_arm="armv8b-${CTARGET#*-}"
- ;;
- *)
- export CHOST_arm="armv8l-${CTARGET#*-}"
- ;;
- esac;
- CHOST_arm=${CHOST_arm/%-gnu/-gnueabi};
- export CTARGET_arm=${CHOST_arm};
- export LIBDIR_arm="lib";
- export CFLAGS_arm64=${CFLAGS_arm64-};
- export CHOST_arm64=${CTARGET};
- export CTARGET_arm64=${CHOST_arm64};
- export LIBDIR_arm64="lib64";
- : ${MULTILIB_ABIS=arm64};
- : ${DEFAULT_ABI=arm64}
- ;;
- x86_64*)
- export CFLAGS_x86=${CFLAGS_x86--m32};
- export CHOST_x86=${CTARGET/x86_64/i686};
- CHOST_x86=${CHOST_x86/%-gnux32/-gnu};
- export CTARGET_x86=${CHOST_x86};
- if [[ ${SYMLINK_LIB} == "yes" ]]; then
- export LIBDIR_x86="lib32";
- else
- export LIBDIR_x86="lib";
- fi;
- export CFLAGS_amd64=${CFLAGS_amd64--m64};
- export CHOST_amd64=${CTARGET/%-gnux32/-gnu};
- export CTARGET_amd64=${CHOST_amd64};
- export LIBDIR_amd64="lib64";
- export CFLAGS_x32=${CFLAGS_x32--mx32};
- export CHOST_x32=${CTARGET/%-gnu/-gnux32};
- export CTARGET_x32=${CHOST_x32};
- export LIBDIR_x32="libx32";
- case ${CTARGET} in
- *-gnux32)
- : ${MULTILIB_ABIS=x32 amd64 x86};
- : ${DEFAULT_ABI=x32}
- ;;
- *)
- : ${MULTILIB_ABIS=amd64 x86};
- : ${DEFAULT_ABI=amd64}
- ;;
- esac
- ;;
- mips64* | mipsisa64*)
- export CFLAGS_o32=${CFLAGS_o32--mabi=32};
- export CHOST_o32=${CTARGET/mips64/mips};
- export CHOST_o32=${CHOST_o32/mipsisa64/mipsisa32};
- export CTARGET_o32=${CHOST_o32};
- export LIBDIR_o32="lib";
- export CFLAGS_n32=${CFLAGS_n32--mabi=n32};
- export CHOST_n32=${CTARGET};
- export CTARGET_n32=${CHOST_n32};
- export LIBDIR_n32="lib32";
- export CFLAGS_n64=${CFLAGS_n64--mabi=64};
- export CHOST_n64=${CTARGET};
- export CTARGET_n64=${CHOST_n64};
- export LIBDIR_n64="lib64";
- : ${MULTILIB_ABIS=n64 n32 o32};
- : ${DEFAULT_ABI=n32}
- ;;
- powerpc64*)
- export CFLAGS_ppc=${CFLAGS_ppc--m32};
- export CHOST_ppc=${CTARGET/powerpc64/powerpc};
- export CTARGET_ppc=${CHOST_ppc};
- export LIBDIR_ppc="lib";
- export CFLAGS_ppc64=${CFLAGS_ppc64--m64};
- export CHOST_ppc64=${CTARGET};
- export CTARGET_ppc64=${CHOST_ppc64};
- export LIBDIR_ppc64="lib64";
- : ${MULTILIB_ABIS=ppc64 ppc};
- : ${DEFAULT_ABI=ppc64}
- ;;
- s390x*)
- export CFLAGS_s390=${CFLAGS_s390--m31};
- export CHOST_s390=${CTARGET/s390x/s390};
- export CTARGET_s390=${CHOST_s390};
- export LIBDIR_s390="lib";
- export CFLAGS_s390x=${CFLAGS_s390x--m64};
- export CHOST_s390x=${CTARGET};
- export CTARGET_s390x=${CHOST_s390x};
- export LIBDIR_s390x="lib64";
- : ${MULTILIB_ABIS=s390x s390};
- : ${DEFAULT_ABI=s390x}
- ;;
- sparc64*)
- export CFLAGS_sparc32=${CFLAGS_sparc32--m32};
- export CHOST_sparc32=${CTARGET/sparc64/sparc};
- export CTARGET_sparc32=${CHOST_sparc32};
- export LIBDIR_sparc32="lib";
- export CFLAGS_sparc64=${CFLAGS_sparc64--m64};
- export CHOST_sparc64=${CTARGET};
- export CTARGET_sparc64=${CHOST_sparc64};
- export LIBDIR_sparc64="lib64";
- : ${MULTILIB_ABIS=sparc64 sparc32};
- : ${DEFAULT_ABI=sparc64}
- ;;
- *)
- : ${MULTILIB_ABIS=default};
- : ${DEFAULT_ABI=default}
- ;;
- esac;
- export MULTILIB_ABIS DEFAULT_ABI
- }
- multilib_for_best_abi ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ ${EAPI} == [45] ]] || die "${FUNCNAME} is banned in EAPI ${EAPI}, use multilib_is_native_abi() instead";
- eqawarn "QA warning: multilib_for_best_abi() function is deprecated and should";
- eqawarn "not be used. The multilib_is_native_abi() check may be used instead.";
- local MULTIBUILD_VARIANTS=($(multilib_get_enabled_abi_pairs));
- multibuild_for_best_variant _multilib_multibuild_wrapper "${@}"
- }
- multilib_foreach_abi ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local MULTIBUILD_VARIANTS=($(multilib_get_enabled_abi_pairs));
- multibuild_foreach_variant _multilib_multibuild_wrapper "${@}"
- }
- multilib_get_enabled_abi_pairs ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local abis=($(get_all_abis));
- local abi i found;
- for abi in "${abis[@]}";
- do
- for i in "${_MULTILIB_FLAGS[@]}";
- do
- local m_abis=${i#*:} m_abi;
- local m_flag=${i%:*};
- for m_abi in ${m_abis//,/ };
- do
- if [[ ${m_abi} == ${abi} ]] && {
- [[ ! -n "${MULTILIB_COMPAT[@]}" ]] || has "${m_flag}" "${MULTILIB_COMPAT[@]}"
- } && use "${m_flag}"; then
- echo "${m_flag}.${abi}";
- found=1;
- break 2;
- fi;
- done;
- done;
- done;
- if [[ ! -n ${found} ]]; then
- local abi=${ABI:-${DEFAULT_ABI}};
- debug-print "${FUNCNAME}: no ABIs enabled, fallback to ${abi}";
- debug-print "${FUNCNAME}: ABI=${ABI}, DEFAULT_ABI=${DEFAULT_ABI}";
- echo ".${abi}";
- fi
- }
- multilib_get_enabled_abis ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local pairs=($(multilib_get_enabled_abi_pairs));
- echo "${pairs[@]#*.}"
- }
- multilib_install_wrappers ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ ${#} -le 1 ]] || die "${FUNCNAME}: too many arguments";
- [[ ${COMPLETE_MULTILIB} == yes ]] && return;
- local root=${1:-${ED}};
- if [[ -d ${ED%/}/tmp/multilib-include ]]; then
- multibuild_merge_root "${ED%/}"/tmp/multilib-include "${root}"/usr/include;
- rmdir "${ED%/}"/tmp &> /dev/null;
- fi
- }
- multilib_is_native_abi ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ ${#} -eq 0 ]] || die "${FUNCNAME}: too many arguments";
- [[ ${COMPLETE_MULTILIB} == yes || ${ABI} == ${DEFAULT_ABI} ]]
- }
- multilib_native_enable ()
- {
- if multilib_is_native_abi; then
- echo "--enable-${1}${2+=${2}}";
- else
- echo "--disable-${1}";
- fi
- }
- multilib_native_use_enable ()
- {
- if multilib_is_native_abi; then
- use_enable "${@}";
- else
- echo "--disable-${2:-${1}}";
- fi
- }
- multilib_native_use_with ()
- {
- if multilib_is_native_abi; then
- use_with "${@}";
- else
- echo "--without-${2:-${1}}";
- fi
- }
- multilib_native_usex ()
- {
- if multilib_is_native_abi; then
- usex "${@}";
- else
- echo "${3-no}${5}";
- fi
- }
- multilib_native_with ()
- {
- if multilib_is_native_abi; then
- echo "--with-${1}${2+=${2}}";
- else
- echo "--without-${1}";
- fi
- }
- multilib_parallel_foreach_abi ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local MULTIBUILD_VARIANTS=($(multilib_get_enabled_abi_pairs));
- multibuild_foreach_variant _multilib_multibuild_wrapper "${@}"
- }
- multilib_prepare_wrappers ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- [[ ${#} -le 1 ]] || die "${FUNCNAME}: too many arguments";
- local root=${1:-${ED%/}};
- local f;
- if [[ ${COMPLETE_MULTILIB} == yes ]]; then
- for f in "${MULTILIB_CHOST_TOOLS[@]}";
- do
- f=${f#/};
- local dir=${f%/*};
- local fn=${f##*/};
- ln -s "${fn}" "${root}/${dir}/${CHOST}-${fn}" || die;
- done;
- return;
- fi;
- for f in "${MULTILIB_CHOST_TOOLS[@]}";
- do
- f=${f#/};
- local dir=${f%/*};
- local fn=${f##*/};
- if [[ -L ${root}/${f} ]]; then
- local target;
- target=$(readlink "${root}/${f}") || die;
- local target_dir target_fn=${target##*/};
- [[ ${target} == */* ]] && target_dir=${target%/*};
- ln -f -s "${target_dir+${target_dir}/}${CHOST}-${target_fn}" "${root}/${f}" || die;
- fi;
- mv "${root}/${f}" "${root}/${dir}/${CHOST}-${fn}" || die;
- if multilib_is_native_abi; then
- ln -s "${CHOST}-${fn}" "${root}/${f}" || die;
- fi;
- done;
- if [[ -n ${MULTILIB_WRAPPED_HEADERS[@]} ]]; then
- if [[ -n ${MULTILIB_ABI_FLAG} ]]; then
- for f in "${MULTILIB_WRAPPED_HEADERS[@]}";
- do
- f=${f#/};
- if [[ ${f} != usr/include/* ]]; then
- die "Wrapping headers outside of /usr/include is not supported at the moment.";
- fi;
- f=${f#usr/include};
- local dir=${f%/*};
- if [[ -f ${root}/usr/include${f} ]]; then
- local wrapper=${ED%/}/tmp/multilib-include${f};
- if [[ ! -f ${ED%/}/tmp/multilib-include${f} ]]; then
- dodir "/tmp/multilib-include${dir}";
- cat > "${wrapper}" <<_EOF_ ||
- /* This file is auto-generated by multilib-build.eclass
- * as a multilib-friendly wrapper. For the original content,
- * please see the files that are #included below.
- */
-
- #if defined(__x86_64__) /* amd64 */
- # if defined(__ILP32__) /* x32 ABI */
- # error "abi_x86_x32 not supported by the package."
- # else /* 64-bit ABI */
- # error "abi_x86_64 not supported by the package."
- # endif
- #elif defined(__i386__) /* plain x86 */
- # error "abi_x86_32 not supported by the package."
- #elif defined(__mips__)
- # if(_MIPS_SIM == _ABIN32) /* n32 */
- # error "abi_mips_n32 not supported by the package."
- # elif(_MIPS_SIM == _ABI64) /* n64 */
- # error "abi_mips_n64 not supported by the package."
- # elif(_MIPS_SIM == _ABIO32) /* o32 */
- # error "abi_mips_o32 not supported by the package."
- # endif
- #elif defined(__sparc__)
- # if defined(__arch64__)
- # error "abi_sparc_64 not supported by the package."
- # else
- # error "abi_sparc_32 not supported by the package."
- # endif
- #elif defined(__s390__)
- # if defined(__s390x__)
- # error "abi_s390_64 not supported by the package."
- # else
- # error "abi_s390_32 not supported by the package."
- # endif
- #elif defined(__powerpc__) || defined(__ppc__)
- # if defined(__powerpc64__) || defined(__ppc64__)
- # error "abi_ppc_64 not supported by the package."
- # else
- # error "abi_ppc_32 not supported by the package."
- # endif
- #elif defined(SWIG) /* https://sourceforge.net/p/swig/bugs/799/ */
- # error "Native ABI not supported by the package."
- #else
- # error "No ABI matched, please report a bug to bugs.gentoo.org"
- #endif
- _EOF_
- die;
- fi
- if ! grep -q "${MULTILIB_ABI_FLAG} " "${wrapper}"; then
- die "Flag ${MULTILIB_ABI_FLAG} not listed in wrapper template. Please report a bug to https://bugs.gentoo.org.";
- fi;
- dodir "/tmp/multilib-include/${CHOST}${dir}";
- mv "${root}/usr/include${f}" "${ED%/}/tmp/multilib-include/${CHOST}${dir}/" || die;
- sed -e "/${MULTILIB_ABI_FLAG} /s&error.*&include <${CHOST}${f}>&" -i "${wrapper}" || die;
- if multilib_is_native_abi; then
- sed -e "/Native ABI/s&error.*&include <${CHOST}${f}>&" -i "${wrapper}" || die;
- fi;
- fi;
- done;
- fi;
- fi
- }
- multilib_src_compile ()
- {
- emake sepermitlockdir="${EPREFIX}/run/sepermit"
- }
- multilib_src_configure ()
- {
- unset BROWSER;
- export ac_cv_header_xcrypt_h=no;
- local myconf=(--with-db-uniquename=-$(db_findver sys-libs/db) --enable-securedir="${EPREFIX}"/$(get_libdir)/security --libdir=/usr/$(get_libdir) --disable-prelude $(use_enable audit) $(use_enable berkdb db) $(use_enable cracklib) $(use_enable debug) $(use_enable nis) $(use_enable nls) $(use_enable pie) $(use_enable selinux) $(use_enable static-libs static) --enable-isadir='.');
- ECONF_SOURCE="${S}" econf ${myconf[@]}
- }
- multilib_src_install ()
- {
- emake DESTDIR="${D}" install sepermitlockdir="${EPREFIX}/run/sepermit";
- local prefix;
- if multilib_is_native_abi; then
- prefix=;
- gen_usr_ldscript -a pam pamc pam_misc;
- else
- prefix=/usr;
- fi;
- local lib;
- for lib in pam pamc pam_misc;
- do
- if ! [[ -f "${ED}"${prefix}/$(get_libdir)/lib${lib}$(get_libname) ]]; then
- dosym lib${lib}$(get_libname 0) ${prefix}/$(get_libdir)/lib${lib}$(get_libname);
- fi;
- done
- }
- multilib_src_install_all ()
- {
- find "${ED}" -type f -name '*.la' -delete || die;
- if use selinux; then
- dodir /usr/lib/tmpfiles.d;
- cat - > "${D}"/usr/lib/tmpfiles.d/${CATEGORY}:${PN}:${SLOT}.conf <<EOF
- d /run/sepermit 0755 root root
- EOF
-
- fi
- }
- multilib_toolchain_setup ()
- {
- local v vv;
- export ABI=$1;
- if [[ ${_DEFAULT_ABI_SAVED} == "true" ]]; then
- for v in CHOST CBUILD AS CC CXX F77 FC LD PKG_CONFIG_{LIBDIR,PATH};
- do
- vv="_abi_saved_${v}";
- [[ ${!vv+set} == "set" ]] && export ${v}="${!vv}" || unset ${v};
- unset ${vv};
- done;
- unset _DEFAULT_ABI_SAVED;
- fi;
- if [[ ${ABI} != ${DEFAULT_ABI} ]]; then
- for v in CHOST CBUILD AS CC CXX F77 FC LD PKG_CONFIG_{LIBDIR,PATH};
- do
- vv="_abi_saved_${v}";
- [[ ${!v+set} == "set" ]] && export ${vv}="${!v}" || unset ${vv};
- done;
- export _DEFAULT_ABI_SAVED="true";
- if [[ ${CBUILD} == "${CHOST}" ]]; then
- export CBUILD=$(get_abi_CHOST $1);
- fi;
- export CHOST=$(get_abi_CHOST ${DEFAULT_ABI});
- export CC="$(tc-getCC) $(get_abi_CFLAGS)";
- export CXX="$(tc-getCXX) $(get_abi_CFLAGS)";
- export F77="$(tc-getF77) $(get_abi_CFLAGS)";
- export FC="$(tc-getFC) $(get_abi_CFLAGS)";
- export LD="$(tc-getLD) $(get_abi_LDFLAGS)";
- export CHOST=$(get_abi_CHOST $1);
- export PKG_CONFIG_LIBDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig;
- export PKG_CONFIG_PATH=${EPREFIX}/usr/share/pkgconfig;
- fi
- }
- number_abis ()
- {
- set -- `get_install_abis`;
- echo $#
- }
- pkg_nofetch ()
- {
- default
- }
- pkg_postinst ()
- {
- ewarn "Some software with pre-loaded PAM libraries might experience";
- ewarn "warnings or failures related to missing symbols and/or versions";
- ewarn "after any update. While unfortunate this is a limit of the";
- ewarn "implementation of PAM and the software, and it requires you to";
- ewarn "restart the software manually after the update.";
- ewarn "";
- ewarn "You can get a list of such software running a command like";
- ewarn " lsof / | egrep -i 'del.*libpam\\.so'";
- ewarn "";
- ewarn "Alternatively, simply reboot your system.";
- fcaps cap_dac_override sbin/unix_chkpwd
- }
- run_in_build_dir ()
- {
- debug-print-function ${FUNCNAME} "${@}";
- local ret;
- [[ ${#} -ne 0 ]] || die "${FUNCNAME}: no command specified.";
- [[ -n ${BUILD_DIR} ]] || die "${FUNCNAME}: BUILD_DIR not set.";
- mkdir -p "${BUILD_DIR}" || die;
- pushd "${BUILD_DIR}" > /dev/null || die;
- "${@}";
- ret=${?};
- popd > /dev/null || die;
- return ${ret}
- }
- src_compile ()
- {
- multilib-minimal_src_compile "$@"
- }
- src_configure ()
- {
- multilib-minimal_src_configure "$@"
- }
- src_install ()
- {
- multilib-minimal_src_install "$@"
- }
- src_prepare ()
- {
- default;
- eapply "${FILESDIR}/${PN}-remove-browsers.patch";
- touch ChangeLog || die;
- eautoreconf
- }
- src_test ()
- {
- multilib-minimal_src_test "$@"
- }
- src_unpack ()
- {
- default
- }
- tc-arch ()
- {
- tc-ninja_magic_to_arch portage "$@"
- }
- tc-arch-kernel ()
- {
- tc-ninja_magic_to_arch kern "$@"
- }
- tc-check-openmp ()
- {
- if ! tc-has-openmp; then
- eerror "Your current compiler does not support OpenMP!";
- if tc-is-gcc; then
- eerror "Enable OpenMP support by building sys-devel/gcc with USE=\"openmp\".";
- else
- if tc-is-clang; then
- eerror "OpenMP support in sys-devel/clang is provided by sys-libs/libomp.";
- fi;
- fi;
- die "Active compiler does not have required support for OpenMP";
- fi
- }
- tc-cpp-is-true ()
- {
- local CONDITION=${1};
- shift;
- local RESULT=$($(tc-getTARGET_CPP) "${@}" -P - <<-EOF 2>/dev/null
- #if ${CONDITION}
- true
- #endif
- EOF
- );
- [[ ${RESULT} == true ]]
- }
- tc-detect-is-softfloat ()
- {
- [[ $(tc-getTARGET_CPP) == "gcc -E" ]] && return 1;
- case ${CTARGET:-${CHOST}} in
- *-newlib | *-elf | *-eabi)
- return 1
- ;;
- arm*)
- if tc-cpp-is-true "defined(__ARM_PCS_VFP)"; then
- echo "no";
- else
- if tc-cpp-is-true "defined(__SOFTFP__)"; then
- echo "yes";
- else
- echo "softfp";
- fi;
- fi;
- return 0
- ;;
- *)
- return 1
- ;;
- esac
- }
- tc-enables-pie ()
- {
- tc-cpp-is-true "defined(__PIE__)" ${CPPFLAGS} ${CFLAGS}
- }
- tc-enables-ssp ()
- {
- tc-cpp-is-true "defined(__SSP__) || defined(__SSP_STRONG__) || defined(__SSP_ALL__)" ${CPPFLAGS} ${CFLAGS}
- }
- tc-enables-ssp-all ()
- {
- tc-cpp-is-true "defined(__SSP_ALL__)" ${CPPFLAGS} ${CFLAGS}
- }
- tc-enables-ssp-strong ()
- {
- tc-cpp-is-true "defined(__SSP_STRONG__) || defined(__SSP_ALL__)" ${CPPFLAGS} ${CFLAGS}
- }
- tc-endian ()
- {
- local host=$1;
- [[ -z ${host} ]] && host=${CTARGET:-${CHOST}};
- host=${host%%-*};
- case ${host} in
- aarch64*be)
- echo big
- ;;
- aarch64)
- echo little
- ;;
- alpha*)
- echo little
- ;;
- arm*b*)
- echo big
- ;;
- arm*)
- echo little
- ;;
- cris*)
- echo little
- ;;
- hppa*)
- echo big
- ;;
- i?86*)
- echo little
- ;;
- ia64*)
- echo little
- ;;
- m68*)
- echo big
- ;;
- mips*l*)
- echo little
- ;;
- mips*)
- echo big
- ;;
- powerpc*le)
- echo little
- ;;
- powerpc*)
- echo big
- ;;
- s390*)
- echo big
- ;;
- sh*b*)
- echo big
- ;;
- sh*)
- echo little
- ;;
- sparc*)
- echo big
- ;;
- x86_64*)
- echo little
- ;;
- *)
- echo wtf
- ;;
- esac
- }
- tc-env_build ()
- {
- tc-export_build_env;
- CFLAGS=${BUILD_CFLAGS} CXXFLAGS=${BUILD_CXXFLAGS} CPPFLAGS=${BUILD_CPPFLAGS} LDFLAGS=${BUILD_LDFLAGS} AR=$(tc-getBUILD_AR) AS=$(tc-getBUILD_AS) CC=$(tc-getBUILD_CC) CPP=$(tc-getBUILD_CPP) CXX=$(tc-getBUILD_CXX) LD=$(tc-getBUILD_LD) NM=$(tc-getBUILD_NM) PKG_CONFIG=$(tc-getBUILD_PKG_CONFIG) RANLIB=$(tc-getBUILD_RANLIB) "$@"
- }
- tc-export ()
- {
- local var;
- for var in "$@";
- do
- [[ $(type -t "tc-get${var}") != "function" ]] && die "tc-export: invalid export variable '${var}'";
- "tc-get${var}" > /dev/null;
- done
- }
- tc-export_build_env ()
- {
- tc-export "$@";
- if tc-is-cross-compiler; then
- : ${BUILD_CFLAGS:=-O1 -pipe};
- : ${BUILD_CXXFLAGS:=-O1 -pipe};
- : ${BUILD_CPPFLAGS:= };
- : ${BUILD_LDFLAGS:= };
- else
- : ${BUILD_CFLAGS:=${CFLAGS}};
- : ${BUILD_CXXFLAGS:=${CXXFLAGS}};
- : ${BUILD_CPPFLAGS:=${CPPFLAGS}};
- : ${BUILD_LDFLAGS:=${LDFLAGS}};
- fi;
- export BUILD_{C,CXX,CPP,LD}FLAGS;
- local v;
- for v in BUILD_{C,CXX,CPP,LD}FLAGS;
- do
- export ${v#BUILD_}_FOR_BUILD="${!v}";
- done
- }
- tc-get-compiler-type ()
- {
- local code='
- #if defined(__PATHSCALE__)
- HAVE_PATHCC
- #elif defined(__clang__)
- HAVE_CLANG
- #elif defined(__GNUC__)
- HAVE_GCC
- #endif
- ';
- local res=$($(tc-getCPP "$@") -E -P - <<<"${code}");
- case ${res} in
- *HAVE_PATHCC*)
- echo pathcc
- ;;
- *HAVE_CLANG*)
- echo clang
- ;;
- *HAVE_GCC*)
- echo gcc
- ;;
- *)
- echo unknown
- ;;
- esac
- }
- tc-getAR ()
- {
- tc-getPROG AR ar "$@"
- }
- tc-getAS ()
- {
- tc-getPROG AS as "$@"
- }
- tc-getBUILD_AR ()
- {
- tc-getBUILD_PROG AR ar "$@"
- }
- tc-getBUILD_AS ()
- {
- tc-getBUILD_PROG AS as "$@"
- }
- tc-getBUILD_CC ()
- {
- tc-getBUILD_PROG CC gcc "$@"
- }
- tc-getBUILD_CPP ()
- {
- tc-getBUILD_PROG CPP "$(tc-getBUILD_CC) -E" "$@"
- }
- tc-getBUILD_CXX ()
- {
- tc-getBUILD_PROG CXX g++ "$@"
- }
- tc-getBUILD_LD ()
- {
- tc-getBUILD_PROG LD ld "$@"
- }
- tc-getBUILD_NM ()
- {
- tc-getBUILD_PROG NM nm "$@"
- }
- tc-getBUILD_OBJCOPY ()
- {
- tc-getBUILD_PROG OBJCOPY objcopy "$@"
- }
- tc-getBUILD_PKG_CONFIG ()
- {
- tc-getBUILD_PROG PKG_CONFIG pkg-config "$@"
- }
- tc-getBUILD_PROG ()
- {
- local vars="BUILD_$1 $1_FOR_BUILD HOST$1";
- tc-is-cross-compiler || vars+=" $1";
- _tc-getPROG CBUILD "${vars}" "${@:2}"
- }
- tc-getBUILD_RANLIB ()
- {
- tc-getBUILD_PROG RANLIB ranlib "$@"
- }
- tc-getBUILD_STRIP ()
- {
- tc-getBUILD_PROG STRIP strip "$@"
- }
- tc-getCC ()
- {
- tc-getPROG CC gcc "$@"
- }
- tc-getCPP ()
- {
- tc-getPROG CPP "${CC:-gcc} -E" "$@"
- }
- tc-getCXX ()
- {
- tc-getPROG CXX g++ "$@"
- }
- tc-getDLLWRAP ()
- {
- tc-getPROG DLLWRAP dllwrap "$@"
- }
- tc-getF77 ()
- {
- tc-getPROG F77 gfortran "$@"
- }
- tc-getFC ()
- {
- tc-getPROG FC gfortran "$@"
- }
- tc-getGCJ ()
- {
- tc-getPROG GCJ gcj "$@"
- }
- tc-getGO ()
- {
- tc-getPROG GO gccgo "$@"
- }
- tc-getLD ()
- {
- tc-getPROG LD ld "$@"
- }
- tc-getNM ()
- {
- tc-getPROG NM nm "$@"
- }
- tc-getOBJCOPY ()
- {
- tc-getPROG OBJCOPY objcopy "$@"
- }
- tc-getOBJDUMP ()
- {
- tc-getPROG OBJDUMP objdump "$@"
- }
- tc-getPKG_CONFIG ()
- {
- tc-getPROG PKG_CONFIG pkg-config "$@"
- }
- tc-getPROG ()
- {
- _tc-getPROG CHOST "$@"
- }
- tc-getRANLIB ()
- {
- tc-getPROG RANLIB ranlib "$@"
- }
- tc-getRC ()
- {
- tc-getPROG RC windres "$@"
- }
- tc-getSTRIP ()
- {
- tc-getPROG STRIP strip "$@"
- }
- tc-getTARGET_CPP ()
- {
- if [[ -n ${CTARGET} ]]; then
- _tc-getPROG CTARGET TARGET_CPP "gcc -E" "$@";
- else
- tc-getCPP "$@";
- fi
- }
- tc-has-openmp ()
- {
- local base="${T}/test-tc-openmp";
- cat > "${base}.c" <<-EOF
- #include <omp.h>
- int main() {
- int nthreads, tid, ret = 0;
- #pragma omp parallel private(nthreads, tid)
- {
- tid = omp_get_thread_num();
- nthreads = omp_get_num_threads(); ret += tid + nthreads;
- }
- return ret;
- }
- EOF
-
- $(tc-getCC "$@") -fopenmp "${base}.c" -o "${base}" &> /dev/null;
- local ret=$?;
- rm -f "${base}"*;
- return ${ret}
- }
- tc-has-tls ()
- {
- local base="${T}/test-tc-tls";
- cat > "${base}.c" <<-EOF
- int foo(int *i) {
- static __thread int j = 0;
- return *i ? j : *i;
- }
- EOF
-
- local flags;
- case $1 in
- -s)
- flags="-S"
- ;;
- -c)
- flags="-c"
- ;;
- -l)
-
- ;;
- -*)
- die "Usage: tc-has-tls [-c|-l] [toolchain prefix]"
- ;;
- esac;
- : ${flags:=-fPIC -shared -Wl,-z,defs};
- [[ $1 == -* ]] && shift;
- $(tc-getCC "$@") ${flags} "${base}.c" -o "${base}" &> /dev/null;
- local ret=$?;
- rm -f "${base}"*;
- return ${ret}
- }
- tc-is-clang ()
- {
- [[ $(tc-get-compiler-type) == clang ]]
- }
- tc-is-cross-compiler ()
- {
- [[ ${CBUILD:-${CHOST}} != ${CHOST} ]]
- }
- tc-is-gcc ()
- {
- [[ $(tc-get-compiler-type) == gcc ]]
- }
- tc-is-softfloat ()
- {
- tc-detect-is-softfloat || tc-tuple-is-softfloat
- }
- tc-is-static-only ()
- {
- local host=${CTARGET:-${CHOST}};
- [[ ${host} == *-mint* ]]
- }
- tc-ld-disable-gold ()
- {
- if ! tc-ld-is-gold "$@"; then
- return;
- fi;
- ewarn "Forcing usage of the BFD linker instead of GOLD";
- local ld=$(tc-getLD "$@");
- local bfd_ld="${ld%% *}.bfd";
- local path_ld=$(which "${bfd_ld}" 2>/dev/null);
- [[ -e ${path_ld} ]] && export LD=${bfd_ld};
- local fallback="true";
- if tc-is-gcc; then
- local major=$(gcc-major-version "$@");
- local minor=$(gcc-minor-version "$@");
- if [[ ${major} -gt 4 ]] || [[ ${major} -eq 4 && ${minor} -ge 8 ]]; then
- export LDFLAGS="${LDFLAGS} -fuse-ld=bfd";
- fallback="false";
- fi;
- else
- if tc-is-clang; then
- local major=$(clang-major-version "$@");
- local minor=$(clang-minor-version "$@");
- if [[ ${major} -gt 3 ]] || [[ ${major} -eq 3 && ${minor} -ge 5 ]]; then
- export LDFLAGS="${LDFLAGS} -fuse-ld=bfd";
- fallback="false";
- fi;
- fi;
- fi;
- if [[ ${fallback} == "true" ]]; then
- if [[ -e ${path_ld} ]]; then
- local d="${T}/bfd-linker";
- mkdir -p "${d}";
- ln -sf "${path_ld}" "${d}"/ld;
- export LDFLAGS="${LDFLAGS} -B${d}";
- else
- die "unable to locate a BFD linker to bypass gold";
- fi;
- fi
- }
- tc-ld-is-gold ()
- {
- local out;
- out=$($(tc-getLD "$@") --version 2>&1);
- if [[ ${out} == *"GNU gold"* ]]; then
- return 0;
- fi;
- local base="${T}/test-tc-gold";
- cat > "${base}.c" <<-EOF
- int main() { return 0; }
- EOF
-
- out=$($(tc-getCC "$@") ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} -Wl,--version "${base}.c" -o "${base}" 2>&1);
- rm -f "${base}"*;
- if [[ ${out} == *"GNU gold"* ]]; then
- return 0;
- fi;
- return 1
- }
- tc-ninja_magic_to_arch ()
- {
- function ninj ()
- {
- [[ ${type} == "kern" ]] && echo $1 || echo $2
- };
- local type=$1;
- local host=$2;
- [[ -z ${host} ]] && host=${CTARGET:-${CHOST}};
- case ${host} in
- aarch64*)
- echo arm64
- ;;
- alpha*)
- echo alpha
- ;;
- arm*)
- echo arm
- ;;
- avr*)
- ninj avr32 avr
- ;;
- bfin*)
- ninj blackfin bfin
- ;;
- c6x*)
- echo c6x
- ;;
- cris*)
- echo cris
- ;;
- frv*)
- echo frv
- ;;
- hexagon*)
- echo hexagon
- ;;
- hppa*)
- ninj parisc hppa
- ;;
- i?86*)
- if [[ ${type} == "kern" && ${host} == *freebsd* ]]; then
- echo i386;
- else
- echo x86;
- fi
- ;;
- ia64*)
- echo ia64
- ;;
- m68*)
- echo m68k
- ;;
- metag*)
- echo metag
- ;;
- microblaze*)
- echo microblaze
- ;;
- mips*)
- echo mips
- ;;
- nios2*)
- echo nios2
- ;;
- nios*)
- echo nios
- ;;
- or1k | or32*)
- echo openrisc
- ;;
- powerpc*)
- if [[ ${type} == "kern" ]]; then
- echo powerpc;
- else
- if [[ ${host} == powerpc64* ]]; then
- echo ppc64;
- else
- echo ppc;
- fi;
- fi
- ;;
- riscv*)
- echo riscv
- ;;
- s390*)
- echo s390
- ;;
- score*)
- echo score
- ;;
- sh64*)
- ninj sh64 sh
- ;;
- sh*)
- echo sh
- ;;
- sparc64*)
- ninj sparc64 sparc
- ;;
- sparc*)
- [[ ${PROFILE_ARCH} == "sparc64" ]] && ninj sparc64 sparc || echo sparc
- ;;
- tile*)
- echo tile
- ;;
- vax*)
- echo vax
- ;;
- x86_64*freebsd*)
- echo amd64
- ;;
- x86_64*)
- if [[ ${type} == "kern" ]]; then
- echo x86;
- else
- echo amd64;
- fi
- ;;
- xtensa*)
- echo xtensa
- ;;
- *)
- echo unknown
- ;;
- esac
- }
- tc-stack-grows-down ()
- {
- case ${ARCH} in
- hppa | metag)
- return 1
- ;;
- esac;
- return 0
- }
- tc-tuple-is-softfloat ()
- {
- local CTARGET=${CTARGET:-${CHOST}};
- case ${CTARGET//_/-} in
- bfin* | h8300*)
- echo "only"
- ;;
- *-softfloat-*)
- echo "yes"
- ;;
- *-softfp-*)
- echo "softfp"
- ;;
- arm*-hardfloat-* | arm*eabihf)
- echo "no"
- ;;
- *-newlib | *-elf | *-eabi)
- echo "no"
- ;;
- arm*)
- echo "yes"
- ;;
- *)
- echo "no"
- ;;
- esac
- }
- uclibctoolize ()
- {
- die "Use elibtoolize"
- }
- ver_cut ()
- {
- local range=${1};
- local v=${2:-${PV}};
- local start end;
- local -a comp;
- _ver_split "${v}";
- local max=$((${#comp[@]}/2));
- _ver_parse_range "${range}" "${max}";
- if [[ ${start} -gt 0 ]]; then
- start=$(( start*2 - 1 ));
- fi;
- printf "%s" "${comp[@]:start:end*2-start}" '
- '
- }
- ver_rs ()
- {
- local v;
- (( ${#} & 1 )) && v=${@: -1} || v=${PV};
- local start end i;
- local -a comp;
- _ver_split "${v}";
- local max=$((${#comp[@]}/2 - 1));
- while [[ ${#} -ge 2 ]]; do
- _ver_parse_range "${1}" "${max}";
- for ((i = start*2; i <= end*2; i+=2 ))
- do
- [[ ${i} -eq 0 && -z ${comp[i]} ]] && continue;
- comp[i]=${2};
- done;
- shift 2;
- done;
- local IFS=;
- echo "${comp[*]}"
- }
- ver_test ()
- {
- local va op vb;
- if [[ $# -eq 3 ]]; then
- va=${1};
- shift;
- else
- va=${PVR};
- fi;
- [[ $# -eq 2 ]] || die "${FUNCNAME}: bad number of arguments";
- op=${1};
- vb=${2};
- case ${op} in
- -eq | -ne | -lt | -le | -gt | -ge)
-
- ;;
- *)
- die "${FUNCNAME}: invalid operator: ${op}"
- ;;
- esac;
- _ver_compare "${va}" "${vb}";
- test $? "${op}" 2
- }
-